﻿using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Data.Entity.Infrastructure;
using System.Linq;
using System.Net;
using System.Web.Http;
using System.Web.Http.Description;
using AppinyaLib.Database;

namespace Appinya.Controllers
{
    public class PersonasController : ApiController
    {
        private castellersEntities db = new castellersEntities();

        // GET: api/Personas
        public List<CASTELLER> GetPersona()
        {
            return db.CASTELLER.ToList();
        }

        // GET: api/Personas/5
        [ResponseType(typeof(CASTELLER))]
        public IHttpActionResult GetPersona(Guid id)
        {
            CASTELLER persona = db.CASTELLER.Find(id);
            if (persona == null)
            {
                return NotFound();
            }

            return Ok(persona);
        }

        // PUT: api/Personas/5
        [ResponseType(typeof(void))]
        public IHttpActionResult PutPersona(int id, CASTELLER persona)
        {
            if (!ModelState.IsValid)
            {
                return BadRequest(ModelState);
            }

            if (id != persona.ID_CASTELLER)
            {
                return BadRequest();
            }

            db.Entry(persona).State = EntityState.Modified;

            try
            {
                db.SaveChanges();
            }
            catch (DbUpdateConcurrencyException)
            {
                if (!PersonaExists(id))
                {
                    return NotFound();
                }
                else
                {
                    throw;
                }
            }

            return StatusCode(HttpStatusCode.NoContent);
        }

        // POST: api/Personas
        [ResponseType(typeof(CASTELLER))]
        public IHttpActionResult PostPersona(CASTELLER persona)
        {
            if (!ModelState.IsValid)
            {
                return BadRequest(ModelState);
            }

            db.CASTELLER.Add(persona);

            try
            {
                db.SaveChanges();
            }
            catch (DbUpdateException)
            {
                if (PersonaExists(persona.ID_CASTELLER))
                {
                    return Conflict();
                }
                else
                {
                    throw;
                }
            }

            return CreatedAtRoute("DefaultApi", new { id = persona.ID_CASTELLER }, persona);
        }

        // DELETE: api/Personas/5
        [ResponseType(typeof(CASTELLER))]
        public IHttpActionResult DeletePersona(Guid id)
        {
            CASTELLER persona = db.CASTELLER.Find(id);
            if (persona == null)
            {
                return NotFound();
            }

            db.CASTELLER.Remove(persona);
            db.SaveChanges();

            return Ok(persona);
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }

        private bool PersonaExists(int id)
        {
            return db.CASTELLER.Count(e => e.ID_CASTELLER == id) > 0;
        }
    }
}