"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require("@angular/core");
var http_1 = require("@angular/http");
var Rx_1 = require("rxjs/Rx");
var PeopleService = (function () {
    function PeopleService(http) {
        this.http = http;
        this.baseUrl = 'http://DESKTOP-9OSANJB/Appinya/api';
    }
    PeopleService.prototype.getAll = function () {
        var people$ = this.http
            .get(this.baseUrl + "/personas", { headers: this.getHeaders() })
            .map(mapPersons)
            .catch(handleError);
        return people$;
    };
    PeopleService.prototype.get = function (id) {
        var person$ = this.http
            .get(this.baseUrl + "/personas/" + id, { headers: this.getHeaders() })
            .map(mapPerson);
        return person$;
    };
    PeopleService.prototype.save = function (person) {
        // this won't actually work because the StarWars API doesn't
        // is read-only. But it would look like this:
        return this.http
            .put(this.baseUrl + "/personas/" + person.id, JSON.stringify(person), { headers: this.getHeaders() });
    };
    PeopleService.prototype.getHeaders = function () {
        var headers = new http_1.Headers();
        headers.append('Accept', 'application/json');
        return headers;
    };
    return PeopleService;
}());
PeopleService = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [http_1.Http])
], PeopleService);
exports.PeopleService = PeopleService;
function mapPersons(response) {
    // uncomment to simulate error:
    // throw new Error('ups! Force choke!');
    // The response of the API has a results
    // property with the actual results
    return response.json().map(toPerson);
}
function toPerson(r) {
    var person = ({
        id: r.id,
        nombre: r.nombre,
        apellidos: r.apellidos,
        email: r.email
    });
    console.log('Parsed person:', person);
    return person;
}
function mapPerson(response) {
    // toPerson looks just like in the previous example
    return toPerson(response.json());
}
// this could also be a private method of the component class
function handleError(error) {
    // log error
    // could be something more sofisticated
    var errorMsg = error.message || "Yikes! There was was a problem with our hyperdrive device and we couldn't retrieve your data!";
    console.error(errorMsg);
    // throw an application level error
    return Rx_1.Observable.throw(errorMsg);
}
//# sourceMappingURL=people.service.js.map