import { Component, OnInit } from '@angular/core';
import { Person } from './person';
import { PeopleService } from './people.service';
@Component({
    selector: 'my-app',
    templateUrl: 'app.component.html',
    styleUrls: [ 'app.component.css'],
    moduleId: module.id,
    providers: [PeopleService]
})
export class AppComponent  implements OnInit {  
    people: Person[] = [];
    errorMessage: string = '';
    isLoading: boolean = true;

    constructor(private peopleService: PeopleService) { }

    ngOnInit() {
        this.peopleService
            .getAll()
            .subscribe(
           p => this.people = p,
          e => this.errorMessage = e,
          () => this.isLoading = false);
    }
}
