﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Globalization;
/// <summary>
/// Aplicació de Gestió Castellera
/// </summary>
/// <copyright>
/// Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
/// </copyright>
/// <author>
/// Daniel Horta Vidal
/// </author>
namespace AppinyaLib.Api
{
    public static class ApiFunctions
    {
        private   const String DATE_FORMAT = "yyyy-MM-dd";
        private  const String HOUR_FORMAT = "HH:mm";
        private const String DATE_HOUR_FORMAT = "yyyy-MM-ddTHH:mm:ss.FFF"; 

        public static DateTime convertApiDate (String dateStr)
        { 
            return DateTime.ParseExact(dateStr, DATE_FORMAT, CultureInfo.InvariantCulture);
        }

        public static DateTime convertApiDateHour(String dateHourStr)
        {
            return DateTime.ParseExact(dateHourStr, DATE_HOUR_FORMAT, CultureInfo.InvariantCulture);
        }
        public static String convertApiDate(DateTime date)
        {
            return date.ToString(DATE_FORMAT, CultureInfo.InvariantCulture);
        }
        public static String convertApiDateHour(DateTime date)
        {
            return date.ToString(DATE_HOUR_FORMAT, CultureInfo.InvariantCulture);
        }
        public static String convertApiHour(DateTime hour)
        {
            return hour.ToString(HOUR_FORMAT, CultureInfo.InvariantCulture);
        }
        
    }
}
