﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using AppinyaLib.Database;
/// <summary>
/// Aplicació de Gestió Castellera
/// </summary>
/// <copyright>
/// Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
/// </copyright>
/// <author>
/// Daniel Horta Vidal
/// </author>
namespace AppinyaLib.Api.Entities
{
    public class Casteller
    {
        public int Id { get; set; }
        public String IdUser { get; set; }
        public String Name { get; set; }
        public String LastName { get; set; }
        public String Alias { get; set; }
        public String Email { get; set; }
        public String Phone1 { get; set; }
        public String Phone2 { get; set; }
        public DateTime? BirdhDay { get; set; }
        public Boolean HasShirt { get; set; }
        public DateTime? ShirtDateDelivery{ get; set; }
        public Decimal? Dept { get; set; }
        public Boolean Cancelation { get; set; }
        public DateTime? CancelationDate { get; set; }
        public DateTime? DateSignUp { get; set; }
        public List<Assistencia> ConfirmPrecence { get; set; }
        public List<Casteller> DelegacioPropia { get; set; }
        public List<Casteller> AccepDelegacioPropia { get; set; }
        public List<Casteller> Invitations { get; set; }
        public List<Casteller> AccepInvitations { get; set; }

        /*
        public DateTime? BirdhDay
        {
            set
            {
                if (value.HasValue)
                    BirdhDayStr = ApiFunctions.convertApiDate(value.Value); 
            }
        }
        public DateTime? ShirtDateDelivery
        {
            set
            {
                if (value.HasValue)
                    ShirtDateDeliveryStr = ApiFunctions.convertApiDate(value.Value);
            }
        }
        public DateTime DateSignUp
        {
            set
            {

                DateSignUpStr = ApiFunctions.convertApiDate(value);
            }
        }
        public DateTime? CancelationDate
        {
            set
            {
                if (value.HasValue)
                    CancelationDateStr = ApiFunctions.convertApiDate(value.Value); 
            }
        }*/
        public static implicit operator Casteller(CASTELLER cas)
        {
            if (cas == null) return null;
            return new Casteller
            {
                Id = cas.ID_CASTELLER,
                IdUser = cas.USER_ID,
                Name = cas.NOM,
                LastName = cas.COGNOMS,
                Alias = cas.ALIAS,
                Email = cas.EMAIL,
                Phone1 = cas.TELEFON1,
                Phone2 = cas.TELEFON2,
                BirdhDay = cas.DATA_NAIXEMENT,
                DateSignUp = cas.DATA_ALTA,
                HasShirt = cas.TE_CAMISA,
                Dept = cas.DEUTE,
                Cancelation = cas.ES_BAIXA,
                CancelationDate = cas.DATA_BAIXA, 
                ShirtDateDelivery =cas.DATA_LLIUREAMENT ,             

            };
        }

    }
}
