﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using AppinyaLib.Api; 
using AppinyaLib.Database;
/// <summary>
/// Aplicació de Gestió Castellera
/// </summary>
/// <copyright>
/// Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
/// </copyright>
/// <author>
/// Daniel Horta Vidal
/// </author>
namespace AppinyaLib.Api.Entities
{
    public class Esdeveniment
    {
        public int Id { get; set; }
        public String Tittle { get; set; }
        public String Description { get; set; }
        public String DateIniStr { get; set; }
        public String HourIniStr { get; set; }
        public String DateFinStr{ get; set; }
        public String HourFinStr { get; set; }
        public String Responsable { get; set; }
        public int EventTypeId { get; set; }
        public String EventType { get; set; }
        public Boolean Confirmat { get; set; }
        public Boolean OfereixTransport { get; set; }
        public DateTime DataFin
        { 
            set {

                HourFinStr = ApiFunctions.convertApiHour(value);
                DateFinStr = ApiFunctions.convertApiDate(value);
            }
        }
        public DateTime DataIni
        {
            set
            {
                HourIniStr = ApiFunctions.convertApiHour(value);
                DateIniStr = ApiFunctions.convertApiDate(value);
            }
        }

        public static implicit operator Esdeveniment(ESDEVENIMENT Est)
        {
            if (Est == null) return null;
            return new Esdeveniment
            {
                Id = Est.ID_ESDEVENIMENT,
                DataFin = Est.DATA_FI,
                DataIni = Est.DATA_INICI,
                Description = Est.TEXT,
                Tittle = Est.TITOL,
                EventTypeId = Est.TIPUS_ESDEVENIMENT.ID_TIPUS_ESDEVENIMENT,
                EventType = Est.TIPUS_ESDEVENIMENT.TITOL,
                Responsable = "",
                Confirmat = false,
                OfereixTransport= Est.OFREIX_TRANSPORT

            };
        }
    }
}