﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using AppinyaLib.Database;
/// <summary>
/// Aplicació de Gestió Castellera
/// </summary>
/// <copyright>
/// Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
/// </copyright>
/// <author>
/// Daniel Horta Vidal
/// </author>
namespace AppinyaLib.Api.Entities
{
    public class UserInfo
    {
        public String Id { get; set; }
        public String Name { get; set; }
        public String LastName { get; set; }
        public String Email { get; set; }
        public Boolean ConfirmEmail { get; set; }
        public Boolean ConfirmCasteller { get; set; }
        public String PhoneNumber { get; set; }
        public String Privilege { get; set; } 
        public Casteller Casteller { get; set; } 
       

        public static implicit operator UserInfo(AspNetUsers users)
        {
            if (users == null) return null;
            return new UserInfo
            {
                Id = users.Id,
                ConfirmEmail = users.EmailConfirmed,
                ConfirmCasteller = false,
                Email = users.Email,
                LastName = users.LastName,
                Name = users.Name,
                PhoneNumber = users.PhoneNumber,
                Privilege = (users.AspNetRoles.Count!=0) ? users.AspNetRoles.FirstOrDefault().Name : ""
            };
        }
    }
}
