﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using AppinyaLib.Database; 
using AppinyaLib.Comunication;
using AppinyaLib.Api.Entities;
/// <summary>
/// Aplicació de Gestió Castellera
/// </summary>
/// <copyright>
/// Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
/// </copyright>
/// <author>
/// Daniel Horta Vidal
/// </author>
namespace AppinyaLib.BS
{
    public static class AssistenciaBs
    {
         
        public static List<Assistencia> SaveAssistencia (List<Assistencia> lst ,String userName)
        {
            
            using (castellersEntities db = new castellersEntities())
            {
                foreach (Assistencia w in lst)
                {
                    ASSISTENCIA assis = db.ASSISTENCIA.Where(ass => ass.ID_CASTELLER == w.Casteller.Id && ass.ID_ESDEVENIMENT == w.Esdeveniment.Id).FirstOrDefault();
                    if (assis == null)
                    {
                        assis = new ASSISTENCIA()
                        {
                            ID_CASTELLER = w.Casteller.Id,
                            ID_ESDEVENIMENT = w.Esdeveniment.Id,
                        }; 
                        db.ASSISTENCIA.Add(assis);
                    }
                    assis.NUM_ACOMPANYANTS = w.NumAcompanyants;
                    assis.TRANSPORT = w.Transport;
                    assis.OBSERVACIONS = w.Observacions;
                }
                db.SaveChanges();
                return UsuariBs.getUserInfo(userName).Casteller.ConfirmPrecence;
            }
            
               
        }
        public static List<Assistencia> RemoveAssistencia(List<Assistencia> lst,String userName)
        { 
            using (castellersEntities db = new castellersEntities())
            {
                foreach (Assistencia w in lst)
                {
                    ASSISTENCIA assis = db.ASSISTENCIA.Where(ass => ass.ID_CASTELLER == w.Casteller.Id && ass.ID_ESDEVENIMENT == w.Esdeveniment.Id).FirstOrDefault();
                    if (assis!= null)
                    {
                        db.ASSISTENCIA.Remove(assis);
                    } 
                }
                db.SaveChanges();
            }
            return UsuariBs.getUserInfo(userName).Casteller.ConfirmPrecence;

        }
        public static List<Assistencia> AssitenciaInvitacions(Esdeveniment esdeveniment, String userName)
        {
            using (castellersEntities db = new castellersEntities())
            {
                CASTELLER owner = db.AspNetUsers.Where(it => it.UserName == userName).Select(t => t).First().CASTELLER.FirstOrDefault();

                List<ASSISTENCIA> assis = (from del in db.CASTELLER_DELEGA
                                     from ass in del.ENVIAR.ASSISTENCIA
                                     where del.CONFIRM==true && del.REBRE.ID_CASTELLER == owner.ID_CASTELLER && ass.ID_ESDEVENIMENT== esdeveniment.Id
                                     select ass).ToList();

                return assis.Select<ASSISTENCIA,Assistencia>(x=>x).ToList();
            }
            

        }



    }
}
