﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using AppinyaLib.Database; 
using AppinyaLib.Comunication;
using AppinyaLib.Api.Entities;
/// <summary>
/// Aplicació de Gestió Castellera
/// </summary>
/// <copyright>
/// Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
/// </copyright>
/// <author>
/// Daniel Horta Vidal
/// </author>
namespace AppinyaLib.BS
{
    public static class EsdevenimentsBs
    {


        public static List<ESDEVENIMENT> GetEsdevenimentsForDataCreacio(DateTime datecreacio)
        {
            List<ESDEVENIMENT> lstEst = null;
            using (castellersEntities db = new castellersEntities())
            {
               
                    lstEst = db.ESDEVENIMENT.Where(Est => Est.DATA_CREACIO.CompareTo(datecreacio)>=0 &&  Est.DATA_FI.CompareTo(DateTime.Now) > 0).Select(Est => Est).ToList();
            }
            return lstEst;

        }

        public static List<ESDEVENIMENT> GetEsdeveniments(Int32 tiposEsdeveniments)
        {
            List<ESDEVENIMENT> lstEst = null;
            using (castellersEntities db = new castellersEntities())
            {
                 if (tiposEsdeveniments!=0)
                    lstEst = (from est in  db.ESDEVENIMENT.Include("TIPUS_ESDEVENIMENT") where est.DATA_FI.CompareTo(DateTime.Now)>0 && est.TIPUS_ESDEVENIMENT.ID_TIPUS_ESDEVENIMENT == tiposEsdeveniments
                              select est).ToList();
                else
                    lstEst = (from est in db.ESDEVENIMENT.Include("TIPUS_ESDEVENIMENT")
                              where est.DATA_FI.CompareTo(DateTime.Now) > 0  
                              select est).ToList();
            }
            return lstEst;
          
        }

        public static List<ESDEVENIMENT> GetEsdevenimentsForUser(String userName)
        {
            if (userName != null) return null;
                List<ESDEVENIMENT> lstEst = null;
            using (castellersEntities db = new castellersEntities())
            {
              
                
                    UserInfo userInfo = UsuariBs.getUserInfo(userName);
                    lstEst = (from est in db.ESDEVENIMENT
                              join ass in db.ASSISTENCIA on est.ID_ESDEVENIMENT equals ass.ID_ESDEVENIMENT
                              where ass.ID_CASTELLER == userInfo.Casteller.Id && est.DATA_FI.CompareTo(DateTime.Now)>0
                              select est).ToList();
                 
            }
            return lstEst;

        }
        public static List<ESDEVENIMENT> GetEsdevenimentsForIdCasteller(int idCasteller)
        {
           
            List<ESDEVENIMENT> lstEst = null;
            using (castellersEntities db = new castellersEntities())
            { 
                    lstEst = (from est in db.ESDEVENIMENT
                              join ass in db.ASSISTENCIA on est.ID_ESDEVENIMENT equals ass.ID_ESDEVENIMENT
                              where ass.ID_CASTELLER == idCasteller && est.DATA_FI.CompareTo(DateTime.Now) > 0
                              select est).ToList(); 
            }
            return lstEst;

        }

        public static void RemoveEsdeveniment (int id)
        {
            using (castellersEntities db = new castellersEntities())
            {

                ESDEVENIMENT es = db.ESDEVENIMENT.Where(it => it.ID_ESDEVENIMENT == id).FirstOrDefault();
                db.ESDEVENIMENT.Remove(es);
            }

        }
         

    }
}
