﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using AppinyaLib.Database;
using AppinyaLib.Comunication;
using AppinyaLib.Api.Entities;
/// <summary>
/// Aplicació de Gestió Castellera
/// </summary>
/// <copyright>
/// Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
/// </copyright>
/// <author>
/// Daniel Horta Vidal
/// </author>
namespace AppinyaLib.BS
{
    public static class UsuariBs
    {
        public static UserInfo getUserInfo(String userName)
        {
            using (castellersEntities db = new castellersEntities())
            {


                UserInfo usr = (from users in db.AspNetUsers
                            where users.UserName == userName
                            select new UserInfo()
                            {
                                Id = users.Id,
                                ConfirmEmail = users.EmailConfirmed,
                                ConfirmCasteller = false,
                                Email = users.Email,
                                LastName = users.LastName,
                                Name = users.Name,
                                PhoneNumber = users.PhoneNumber,
                                Privilege = users.AspNetRoles.FirstOrDefault().Name
                            }).FirstOrDefault();
                if (usr == null) return null;
                if (usr.ConfirmEmail)
                {
                    CASTELLER cas = (from caste in db.CASTELLER.Include("ASSISTENCIA").Include("ASSISTENCIA.ESDEVENIMENT").Include("ENVIAR").Include("ENVIAR.REBRE").Include("REBRE").Include("REBRE.ENVIAR")
                                     where caste.EMAIL == userName
                                    select  caste ).FirstOrDefault();
                    if (cas != null)
                    {
                        if (cas.USER_ID== null)
                        {
                            cas.USER_ID = usr.Id;
                            db.SaveChanges();
                        }
                        usr.ConfirmCasteller = true;
                        usr.Casteller = cas;
                        usr.Casteller.ConfirmPrecence = cas.ASSISTENCIA.Select<ASSISTENCIA, Assistencia>(x => x).ToList();
                        usr.Casteller.DelegacioPropia = cas.ENVIAR.Where(t => t.CONFIRM==false).Select<CASTELLER_DELEGA, Casteller>(x => x.REBRE).ToList();
                        usr.Casteller.AccepDelegacioPropia = cas.ENVIAR.Where(t => t.CONFIRM).Select<CASTELLER_DELEGA, Casteller>(x => x.REBRE).ToList();
                        usr.Casteller.Invitations = cas.REBRE.Where(t => t.CONFIRM == false).Select<CASTELLER_DELEGA, Casteller>(x => x.ENVIAR).ToList();
                        usr.Casteller.AccepInvitations = cas.REBRE.Where(t => t.CONFIRM).Select<CASTELLER_DELEGA, Casteller>(x => x.ENVIAR).ToList(); 
                        //usr.Casteller.º
                       
                     
                    }

                    // usr.EsdevenimentsConfirmats= EsdevenimentsBs.GetEsdevenimentsForIdCasteller(cas.ID_CASTELLER).Select<ESDEVENIMENT,Esdeveniment>(x=>x).ToList();
                }
                return usr;


            }
        }
    }
}
