﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using AppinyaLib.Database;

using System.Web;
 

using System.Net.Mail;

using System.Configuration;

using System.IO;
/// <summary>
/// Aplicació de Gestió Castellera
/// </summary>
/// <copyright>
/// Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
/// </copyright>
/// <author>
/// Daniel Horta Vidal
/// </author>
namespace AppinyaLib.Comunication
{
    public static class SendMail
    {
      

        public static void SendEmailWithHtmlTemplate(String tittle,String email, String urlTemplate, Dictionary<String, String> templateparams)

        { 
            string body = SendMail.createEmailBody(urlTemplate, templateparams);

            SendMail.SendHtmlFormattedEmail(tittle, body, email);

        }

        private static void SendHtmlFormattedEmail(string subject, string body ,string email)

        {

            using (MailMessage mailMessage = new MailMessage())

            {

                mailMessage.From = new MailAddress(  ConfigurationManager.AppSettings["mail-from"]);

                mailMessage.Subject = subject;

                mailMessage.Body = body;

                mailMessage.IsBodyHtml = true;

                mailMessage.To.Add( new MailAddress(email));

                SmtpClient smtp = new SmtpClient();

                smtp.Host =  ConfigurationManager.AppSettings["mail-server"];

                smtp.EnableSsl = Convert.ToBoolean(ConfigurationManager.AppSettings["mail-ssl"]);

                System.Net.NetworkCredential NetworkCred = new System.Net.NetworkCredential();

                NetworkCred.UserName =   ConfigurationManager.AppSettings["mail-user"];    

                //Google 
                smtp.DeliveryMethod = SmtpDeliveryMethod.Network;
                NetworkCred.Password =   ConfigurationManager.AppSettings["mail-pass"];    

                smtp.UseDefaultCredentials = true;
                 
                smtp.Credentials = NetworkCred;

                smtp.Port = int.Parse(ConfigurationManager.AppSettings["mail-port"]);  
                System.Net.ServicePointManager.ServerCertificateValidationCallback = delegate (object s,
                        System.Security.Cryptography.X509Certificates.X509Certificate certificate,
                        System.Security.Cryptography.X509Certificates.X509Chain chain,
                        System.Net.Security.SslPolicyErrors sslPolicyErrors)
                {
                    return true;
                };

                smtp.Send(mailMessage);

            }

        }

        private static String createEmailBody(String templateUrl, Dictionary<String,String> paramList)

        { 
            String body = String.Empty;
            //using streamreader for reading my htmltemplate   

            using (StreamReader reader = new StreamReader(templateUrl))
            {
                body = reader.ReadToEnd();

            }
            foreach (String item in paramList.Keys)
                body = body.Replace("{"+ item+ "}", paramList[item]);   

            return body;

        }
     }
}
