﻿/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
**/
import { UserInfo } from './UserInfo'
export interface Publication {
    DateNoticies: string;
    DateEsdeveniments: string;
    Noticies?: Noticies[];
    Esdeveniments?: Esdeveniment[];

}
export interface PublicationCasteller {
    Date: string; 
    Castellers?: Casteller[]; 

}
export interface Casteller {
    Id: string;
    IdUser: string;
    Name: string;
    LastName: string;
    Alias: string;
    Email: string;
    Phone1: string;
    Phone2: string;
    BirthDay: Date;
    DateSignUp: Date;
    HasShirt: Boolean;
    Depts: Number;
    Cancelation: Boolean;
    CancelationDate: Date;
    ConfirmPrecence: Assistencia[];
    DelegacioPropia: Casteller[];
    AccepDelegacioPropia: Casteller[];
    AccepInvitations: Casteller[]; 
    Invitations: Casteller[];
}
export interface Assistencia {
    Casteller: Casteller;
    Esdeveniment: Esdeveniment;
    Transport: boolean;
    NumAcompanyants: number;
    Observacions:String
}
export interface Esdeveniment {
    Id: string;
    Tittle: string;
    Description: string;
    EventTypeId: Number;
    EventType: String;
    DateIni: Date;
    DateFin: Date;
    Responsable: string;
    HourIni: String,
    HourFin: String,
    Confirmat: Boolean,
    OfereixTransport: Boolean
}
export interface Noticies {
    Id: string;
    Tittle: string;
    Description: string;
    Date: Date;
    Url: string;
    UserInfo: UserInfo;
}
