var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Component } from '@angular/core';
import { AlertController, NavController, ToastController } from 'ionic-angular';
import { LoginPage } from '../login/login';
import { SupportPage } from '../support/support';
import { StoreData } from '../../providers/storage.data';
import { AuthenticateService } from '../../providers/authenticate.service';
import { ChangePasswordPage } from '../../pages/account/changePassword';
import { CastellerViewPage } from '../../pages/castellers-det/castellers-view';
var AccountPage = (function () {
    function AccountPage(alertCtrl, nav, storeData, authenticateService, toastCtrl) {
        this.alertCtrl = alertCtrl;
        this.nav = nav;
        this.storeData = storeData;
        this.authenticateService = authenticateService;
        this.toastCtrl = toastCtrl;
    }
    AccountPage.prototype.ngOnInit = function () {
        this.user = this.storeData.getUserSession();
    };
    AccountPage.prototype.updatePicture = function () {
        console.log('Clicked to update picture');
    };
    AccountPage.prototype.goToCasteller = function () {
        this.nav.push(CastellerViewPage, this.user.Casteller);
    };
    AccountPage.prototype.requestEmailConfirm = function () {
        var _this = this;
        this.authenticateService.sendMailConfirmation().subscribe(function (it) {
            var toast = _this.toastCtrl.create({
                message: 'S\'ha enviat el correu correctament',
                duration: 3000
            });
            toast.present();
        }, function (e) {
            var alert = _this.alertCtrl.create({
                title: 'Error - No s\'ha enviat',
                subTitle: "El correu no s'ha pogut enviar",
                message: "Validi que te conectivitat 3G en el seu dispositiu mobil ",
                buttons: ['OK']
            });
            alert.present();
        });
    };
    AccountPage.prototype.changePassword = function () {
        console.log('Clicked to change password');
        this.nav.push(ChangePasswordPage);
    };
    AccountPage.prototype.logout = function () {
        this.storeData.logout();
        this.nav.setRoot(LoginPage);
    };
    AccountPage.prototype.support = function () {
        this.nav.push(SupportPage);
    };
    return AccountPage;
}());
AccountPage = __decorate([
    Component({
        selector: 'page-account',
        templateUrl: 'account.html'
    }),
    __metadata("design:paramtypes", [AlertController, NavController, StoreData,
        AuthenticateService, ToastController])
], AccountPage);
export { AccountPage };
//# sourceMappingURL=account.js.map