/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espaa (CC BY-NC 3.0 ES)
**/
import { Component } from '@angular/core';

import { AlertController, NavController, ToastController } from 'ionic-angular';

import { LoginPage } from '../login/login';
import { SupportPage } from '../support/support';
import { StoreData } from '../../providers/storage.data';
import { AuthenticateService } from '../../providers/authenticate.service';
import { UserInfo } from '../../entities/UserInfo';
import { ChangePasswordPage } from '../../pages/account/changePassword';
import { CastellerViewPage } from '../../pages/castellers-det/castellers-view';
@Component({
  selector: 'page-account',
  templateUrl: 'account.html'
}) 
export class AccountPage {
   public user: UserInfo;

   
   constructor(public alertCtrl: AlertController, public nav: NavController, public storeData: StoreData,
       public authenticateService: AuthenticateService, public toastCtrl: ToastController) {
       
  } 
 
   ngOnInit() { 
       this.user = this.storeData.getUserSession(); 
  }

  updatePicture() {
    console.log('Clicked to update picture');
  }
  goToCasteller() {
      this.nav.push(CastellerViewPage, this.user.Casteller);
  }
  requestEmailConfirm() {
      this.authenticateService.sendMailConfirmation().subscribe(it => {
          let toast = this.toastCtrl.create({
              message: 'S\'ha enviat el correu correctament',
              duration: 3000
          });
          toast.present();
      }, e => { 
          let alert = this.alertCtrl.create({
              title: 'Error - No s\'ha enviat',
              subTitle: "El correu no s'ha pogut enviar",
              message: "Validi que te conectivitat 3G en el seu dispositiu mobil ",
              buttons: ['OK']
          });
          alert.present();
      }
      );

  } 
  changePassword() {
      console.log('Clicked to change password');
      this.nav.push(ChangePasswordPage);
  }

  logout() {
      this.storeData.logout();
    this.nav.setRoot(LoginPage);
  }

  support() {
    this.nav.push(SupportPage);
  }

    
   
}
