/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espaa (CC BY-NC 3.0 ES)
**/
import { Component } from '@angular/core';
import { AlertController, NavController, ToastController  } from 'ionic-angular';
import { Validators } from '@angular/forms'
import { LoginPage } from '../login/login';
import { SupportPage } from '../support/support';
import { StoreData } from '../../providers/storage.data';
import { AuthenticateService } from '../../providers/authenticate.service';
import { UserInfo } from '../../entities/UserInfo';
@Component({
  selector: 'page-changepassword',
  templateUrl: 'changePassword.html'
})
export class ChangePasswordPage {

    error: String = "";
    passwordOld : String = "";
    password: String = "";
    repassword: String = "";
    constructor(public alertCtrl: AlertController, public nav: NavController, public storeData: StoreData,
        public authenticateService: AuthenticateService,
        public toastCtrl: ToastController
        ) {
      
   } 
 
  ngOnInit() {
      // this.model = this.storeData.getUserSession();
  }
  changePassword() { 
      if (!this.passwordOld) {
          this.error = "Los passwords anterior no esta introduit.";
      } else if (!this.password || !this.password || this.password != this.repassword) {
          this.error = "Los passwords no son iguals";
      } else {
          if (this.password.length < 6) this.error = "Los passwords debe ser mayor que 6 caracteres";
          else {
              
              this.authenticateService.changePassword(this.passwordOld, this.password, this.repassword).subscribe(t => {
                  let toast = this.toastCtrl.create({
                      message: 'la contrasenya s\'ha canviat correctament',
                      duration: 3000
                  });
                  toast.present();
                  this.nav.pop();
                  }
                );
          }
      }
       
  }
  resetError() {
      this.error = "";
  }
}
