var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Component } from '@angular/core';
import { NavParams, ViewController, LoadingController, AlertController, ToastController } from 'ionic-angular';
import { AssistenciaService } from '../../providers/assistencia.service';
import { StoreData } from '../../providers/storage.data';
var AssistenciaEditPage = (function () {
    function AssistenciaEditPage(navParams, viewCtrl, loadingCtrl, store, alertCtrl, assistenciaService, toastCtrl) {
        var _this = this;
        this.navParams = navParams;
        this.viewCtrl = viewCtrl;
        this.loadingCtrl = loadingCtrl;
        this.store = store;
        this.alertCtrl = alertCtrl;
        this.assistenciaService = assistenciaService;
        this.toastCtrl = toastCtrl;
        this.delegats = [];
        this.bnew = false;
        this.isenabled = true;
        this.assistencia = this.navParams.get("assistencia");
        this.bnew = (this.navParams.get("type") === "new");
        if (this.store.getUserSession().Casteller.AccepInvitations) {
            var loading_1 = this.loadingCtrl.create({
                content: 'Recollint informacio, de la assistencia'
            });
            loading_1.present();
            this.store.getUserSession().Casteller.AccepInvitations.forEach(function (d) {
                _this.delegats.push({ Id: d.Id, Name: d.Name, LastName: d.LastName, isChecked: false, Casteller: d });
            });
            this.assistenciaService.getAssitenciaInvitacions(this.assistencia.Esdeveniment).subscribe(function (t) {
                loading_1.dismiss();
                _this.isenabled = true;
                t.forEach(function (d) {
                    _this.delegats.forEach(function (del) {
                        if (del.Id == d.Casteller.Id)
                            del.isChecked = true;
                    });
                });
            }, function (e) {
                _this.isenabled = false;
                loading_1.dismiss();
            });
        }
    }
    AssistenciaEditPage.prototype.confirm = function () {
        var _this = this;
        var loading = this.loadingCtrl.create({
            content: 'Esperi, s\'esta enviant la confirmacio al servidor'
        });
        var lstAssistencia = [];
        lstAssistencia.push(this.assistencia);
        this.delegats.forEach(function (t) {
            if (t.isChecked)
                lstAssistencia.push({ Casteller: t.Casteller, Esdeveniment: _this.assistencia.Esdeveniment, NumAcompanyants: 0, Transport: _this.assistencia.Transport, Observacions: _this.assistencia.Observacions });
        });
        loading.present();
        this.assistenciaService.saveAssistencia(lstAssistencia, loading).subscribe(function (res) {
            _this.store.setAssistencia(res);
            loading.dismiss();
            _this.viewCtrl.dismiss(_this.assistencia);
        }, function (err) {
            loading.dismiss();
            var alert = _this.alertCtrl.create({
                title: 'Error en la confirmacio',
                subTitle: "No se a podido confirmar (" + err + ")"
            });
            alert.present();
        });
    };
    AssistenciaEditPage.prototype.dismiss = function (data) {
        this.viewCtrl.dismiss(null);
    };
    return AssistenciaEditPage;
}());
AssistenciaEditPage = __decorate([
    Component({
        selector: 'assistencia-edit',
        templateUrl: 'assistencia-edit.html'
    }),
    __metadata("design:paramtypes", [NavParams,
        ViewController,
        LoadingController,
        StoreData,
        AlertController,
        AssistenciaService,
        ToastController])
], AssistenciaEditPage);
export { AssistenciaEditPage };
//# sourceMappingURL=assistencia-edit.js.map