var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Component, ViewChild } from '@angular/core';
import { AlertController, App, List, ModalController, NavController, LoadingController, ToastController } from 'ionic-angular';
import { AssistenciaService } from '../../providers/assistencia.service';
import { AssistenciaEditPage } from '../assistencia-det/assistencia-edit';
import { StoreData } from '../../providers/storage.data';
var AssistenciaListPage = (function () {
    function AssistenciaListPage(alertCtrl, app, loadingCtrl, modalCtrl, navCtrl, storeData, assistenciaService, toastCtrl) {
        this.alertCtrl = alertCtrl;
        this.app = app;
        this.loadingCtrl = loadingCtrl;
        this.modalCtrl = modalCtrl;
        this.navCtrl = navCtrl;
        this.storeData = storeData;
        this.assistenciaService = assistenciaService;
        this.toastCtrl = toastCtrl;
        this.dayIndex = 0;
        this.queryText = '';
        this.excludeTypes = [];
        this.lstAssistencia = [];
    }
    AssistenciaListPage.prototype.ionViewDidLoad = function () {
        this.app.setTitle('Assistencia');
        this.loadAssistencia();
    };
    AssistenciaListPage.prototype.loadAssistencia = function () {
        // Cierra los elementos
        if (this.storeData.getUserSession().Casteller.ConfirmPrecence) {
            this.lstAssistencia = this.storeData.getUserSession().Casteller.ConfirmPrecence;
        }
        this.assistencialist && this.assistencialist.closeSlidingItems();
    };
    AssistenciaListPage.prototype.showError = function (e) {
        // create an alert instance
        var alert = this.alertCtrl.create({
            title: 'Error in Esdeveniments ' + e
        });
        alert.present();
    };
    AssistenciaListPage.prototype.showDetall = function (assistencia) {
        var _this = this;
        var modal = this.modalCtrl.create(AssistenciaEditPage, { assistencia: assistencia, type: "modify" });
        modal.present();
        modal.onWillDismiss(function (data) {
            if (data) {
                var toast = _this.toastCtrl.create({
                    message: 'S\'ha modificat l\'assistencia amb els nous valors',
                    duration: 3000
                });
                toast.present();
            }
        });
    };
    AssistenciaListPage.prototype.deleteConfirm = function (assistencia) {
        var _this = this;
        var loading = this.loadingCtrl.create({
            content: 'Esperi, s\'esta enviant la confirmacio al servidor'
        });
        loading.present();
        this.assistenciaService.removeAssistencia([assistencia], loading).subscribe(function (t) {
            _this.storeData.setAssistencia(t);
            _this.loadAssistencia();
            loading.dismiss();
            var toast = _this.toastCtrl.create({
                message: 'S\'ha eliminat l\'assistencia amb els nous valors',
                duration: 3000
            });
            toast.present();
        }, function (err) {
            loading.dismiss();
            var alert = _this.alertCtrl.create({
                title: 'Error en la anulacio',
                subTitle: "No se a pogut anular (" + err + ")"
            });
            alert.present();
        });
    };
    return AssistenciaListPage;
}());
__decorate([
    ViewChild('assistencialist', { read: List }),
    __metadata("design:type", List)
], AssistenciaListPage.prototype, "assistencialist", void 0);
AssistenciaListPage = __decorate([
    Component({
        selector: 'assistencia-list',
        templateUrl: 'assistencia-list.html'
    }),
    __metadata("design:paramtypes", [AlertController,
        App,
        LoadingController,
        ModalController,
        NavController,
        StoreData,
        AssistenciaService,
        ToastController])
], AssistenciaListPage);
export { AssistenciaListPage };
//# sourceMappingURL=assistencia-list.js.map