var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Component, ViewChild } from '@angular/core';
import { App, Config, NavController, List, LoadingController, ViewController } from 'ionic-angular';
import { StoreData } from '../../providers/storage.data';
var CastellerSoliPage = (function () {
    function CastellerSoliPage(navCtrl, app, storeData, loadingCtrl, config, viewCtrl) {
        this.navCtrl = navCtrl;
        this.app = app;
        this.storeData = storeData;
        this.loadingCtrl = loadingCtrl;
        this.config = config;
        this.viewCtrl = viewCtrl;
        this.lstCastellers = [];
        this.queryText = "";
    }
    CastellerSoliPage.prototype.ionViewDidLoad = function () {
        this.app.setTitle('Selecciona contacto ...');
        this.load();
    };
    CastellerSoliPage.prototype.load = function () {
        // Close any open sliding items when the schedule updates
        this.castellerlist && this.castellerlist.closeSlidingItems();
        this.lstCastellers = this.storeData.getCastellers();
        this.castellerOwner = this.storeData.getUserSession().Casteller;
    };
    CastellerSoliPage.prototype.confirm = function (casteller) {
        this.viewCtrl.dismiss(casteller);
    };
    CastellerSoliPage.prototype.dismiss = function () {
        this.viewCtrl.dismiss(null);
    };
    CastellerSoliPage.prototype.searchCastellers = function (ev) {
        this.lstCastellers = this.storeData.getCastellers();
        var val = ev.target.value;
        this.lstCastellers = this.lstCastellers.filter(function (item) {
            if ((item.Name.toLowerCase().indexOf(val.toLowerCase()) > -1))
                return true;
            if ((item.LastName.toLowerCase().indexOf(val.toLowerCase()) > -1))
                return true;
            if ((item.Alias.toLowerCase().indexOf(val.toLowerCase()) > -1))
                return true;
            return false;
        });
    };
    return CastellerSoliPage;
}());
__decorate([
    ViewChild('castellerlist', { read: List }),
    __metadata("design:type", List)
], CastellerSoliPage.prototype, "castellerlist", void 0);
CastellerSoliPage = __decorate([
    Component({
        selector: 'castellers-soli',
        templateUrl: 'castellers-soli.html'
    }),
    __metadata("design:paramtypes", [NavController,
        App,
        StoreData,
        LoadingController,
        Config,
        ViewController])
], CastellerSoliPage);
export { CastellerSoliPage };
//# sourceMappingURL=castellers-soli.js.map