/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espaa (CC BY-NC 3.0 ES)
**/
import { Component, ViewChild } from '@angular/core';
import {  App,  Config, NavController, List, LoadingController, ViewController } from 'ionic-angular';  
import { StoreData } from '../../providers/storage.data' 

import { Casteller } from '../../entities/entities'; 
@Component({
  selector: 'castellers-soli',
  templateUrl: 'castellers-soli.html'
})
export class CastellerSoliPage { 
  lstCastellers: Casteller[] = [];
  castellerOwner: Casteller;
  queryText: String = "";
  @ViewChild('castellerlist', { read: List }) castellerlist: List;

  constructor( 
    public navCtrl: NavController,
    public app: App,
    public storeData: StoreData,
    public loadingCtrl: LoadingController,
    public config: Config,
    public viewCtrl: ViewController

  ) { }

  ionViewDidLoad() {
      this.app.setTitle('Selecciona contacto ...');
      this.load();
  }

  load() {
      // Close any open sliding items when the schedule updates
      this.castellerlist && this.castellerlist.closeSlidingItems();
      this.lstCastellers = this.storeData.getCastellers();
      this.castellerOwner = this.storeData.getUserSession().Casteller;
  }

  confirm(casteller: Casteller): void { 
      this.viewCtrl.dismiss(casteller);  
  } 
  dismiss(): void {
      this.viewCtrl.dismiss(null);
  }
  searchCastellers(ev: any) {
      this.lstCastellers = this.storeData.getCastellers();
      var val = ev.target.value;

      this.lstCastellers = this.lstCastellers.filter((item) => {
          if ((item.Name.toLowerCase().indexOf(val.toLowerCase()) > -1))
              return true;
          if ((item.LastName.toLowerCase().indexOf(val.toLowerCase()) > -1))
              return true;
          if ((item.Alias.toLowerCase().indexOf(val.toLowerCase()) > -1))
              return true;
          return false;
      })
  }
}
