var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Component } from '@angular/core';
import { NavController, NavParams, ModalController, ToastController } from 'ionic-angular';
import { CastellerEditPage } from '../castellers-det/castellers-edit';
import { CastellerSoliPage } from '../castellers-det/castellers-soli';
import { StoreData } from '../../providers/storage.data';
import { CastellersService } from '../../providers/castellers.service';
var CastellerViewPage = (function () {
    function CastellerViewPage(navCtrl, navParams, store, modalCtrl, toastCtrl, castellerService) {
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.store = store;
        this.modalCtrl = modalCtrl;
        this.toastCtrl = toastCtrl;
        this.castellerService = castellerService;
        this.isOwner = false;
        this.isOwner = this.navParams.data.Id === this.store.getUserSession().Casteller.Id;
        if (this.isOwner) {
            this.casteller = this.store.getUserSession().Casteller;
        }
        else {
            this.casteller = this.navParams.data;
        }
    }
    CastellerViewPage.prototype.editCasteller = function () {
        this.navCtrl.push(CastellerEditPage, this.casteller);
    };
    CastellerViewPage.prototype.isJunta = function () {
        return this.store.isJunta();
    };
    CastellerViewPage.prototype.addCasteller = function () {
        this.navCtrl.push(CastellerEditPage);
    };
    CastellerViewPage.prototype.solicitudCasteller = function () {
        var _this = this;
        var modal = this.modalCtrl.create(CastellerSoliPage);
        modal.present();
        modal.onWillDismiss(function (data) {
            if (data) {
                _this.castellerService.enviaInvitacio(data).subscribe(function (t) {
                    _this.casteller.DelegacioPropia = t;
                    _this.store.setDelegacioPropia(t);
                    var toast = _this.toastCtrl.create({
                        message: 'S\'ha modificat correctament',
                        duration: 3000
                    });
                }, function (e) {
                    var toast = _this.toastCtrl.create({
                        message: ' No se ha podido contactar con el servidor',
                        duration: 3000
                    });
                    toast.present();
                });
            }
        });
    };
    CastellerViewPage.prototype.acceptarInvitacio = function (casteller) {
        var _this = this;
        this.castellerService.acceptarInvitacio(casteller).subscribe(function (t) {
            _this.casteller.Invitations = t || [];
            _this.casteller.AccepInvitations.push(casteller);
            _this.store.setInvitations(t);
            var toast = _this.toastCtrl.create({
                message: 'S\'ha modificat correctament',
                duration: 3000
            });
            toast.present();
        }, function (e) {
            var toast = _this.toastCtrl.create({
                message: ' No se ha podido contactar con el servidor',
                duration: 3000
            });
            toast.present();
        });
    };
    CastellerViewPage.prototype.esborrarInvitacio = function (casteller) {
        var _this = this;
        this.castellerService.esborrarInvitacio(casteller).subscribe(function (t) {
            _this.casteller.Invitations = t || [];
            _this.store.setInvitations(_this.casteller.Invitations);
            var toast = _this.toastCtrl.create({
                message: 'S\'ha modificat correctament',
                duration: 3000
            });
            toast.present();
        }, function (e) {
            var toast = _this.toastCtrl.create({
                message: ' No se ha podido contactar con el servidor',
                duration: 3000
            });
            toast.present();
        });
    };
    CastellerViewPage.prototype.esborrarAcceptacio = function (casteller) {
        var _this = this;
        this.castellerService.esborrarAcceptacio(casteller).subscribe(function (t) {
            _this.casteller.AccepInvitations = t || [];
            _this.store.setAcceptacions(_this.casteller.AccepInvitations);
            var toast = _this.toastCtrl.create({
                message: 'S\'ha modificat correctament',
                duration: 3000
            });
            toast.present();
        }, function (e) {
            var toast = _this.toastCtrl.create({
                message: ' No se ha podido contactar con el servidor',
                duration: 3000
            });
            toast.present();
        });
    };
    CastellerViewPage.prototype.esborrarDelegacioPropia = function (casteller) {
        var _this = this;
        this.castellerService.esborrarDelegacioPropia(casteller).subscribe(function (t) {
            _this.casteller.DelegacioPropia = t || [];
            _this.store.setDelegacioPropia(_this.casteller.DelegacioPropia);
            var toast = _this.toastCtrl.create({
                message: 'S\'ha modificat correctament',
                duration: 3000
            });
            toast.present();
        }, function (e) {
            var toast = _this.toastCtrl.create({
                message: ' No se ha podido contactar con el servidor',
                duration: 3000
            });
            toast.present();
        });
    };
    CastellerViewPage.prototype.esborrarAcceptDelegacioPropia = function (casteller) {
        var _this = this;
        this.castellerService.esborrarAccepDelegacioPropia(casteller).subscribe(function (t) {
            _this.casteller.AccepDelegacioPropia = t || [];
            _this.store.setAccepDelegacioPropia(_this.casteller.AccepDelegacioPropia);
            var toast = _this.toastCtrl.create({
                message: 'S\'ha modificat correctament',
                duration: 3000
            });
            toast.present();
        }, function (e) {
            var toast = _this.toastCtrl.create({
                message: ' No se ha podido contactar con el servidor',
                duration: 3000
            });
            toast.present();
        });
    };
    return CastellerViewPage;
}());
CastellerViewPage = __decorate([
    Component({
        selector: 'castellers-view',
        templateUrl: 'castellers-view.html'
    }),
    __metadata("design:paramtypes", [NavController,
        NavParams,
        StoreData,
        ModalController,
        ToastController,
        CastellersService])
], CastellerViewPage);
export { CastellerViewPage };
//# sourceMappingURL=castellers-view.js.map