var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Component, ViewChild } from '@angular/core';
import { App, ActionSheetController, Config, NavController, List } from 'ionic-angular';
import { CastellersService } from '../../providers/castellers.service';
import { CastellerViewPage } from '../castellers-det/castellers-view';
import { StoreData } from '../../providers/storage.data';
var CastellerListPage = (function () {
    function CastellerListPage(actionSheetCtrl, navCtrl, app, config, castellerService, storeData) {
        this.actionSheetCtrl = actionSheetCtrl;
        this.navCtrl = navCtrl;
        this.app = app;
        this.config = config;
        this.castellerService = castellerService;
        this.storeData = storeData;
        this.lstCastellers = [];
        this.queryText = "";
    }
    CastellerListPage.prototype.ionViewDidLoad = function () {
        this.app.setTitle('Castellers');
        this.load();
    };
    CastellerListPage.prototype.load = function () {
        this.castellerlist && this.castellerlist.closeSlidingItems();
        this.lstCastellers = this.storeData.getCastellers();
    };
    CastellerListPage.prototype.searchCastellers = function (ev) {
        this.lstCastellers = this.storeData.getCastellers();
        var val = ev.target.value;
        this.lstCastellers = this.lstCastellers.filter(function (item) {
            if ((item.Name.toLowerCase().indexOf(val.toLowerCase()) > -1))
                return true;
            if ((item.LastName.toLowerCase().indexOf(val.toLowerCase()) > -1))
                return true;
            if ((item.Alias.toLowerCase().indexOf(val.toLowerCase()) > -1))
                return true;
            return false;
        });
    };
    CastellerListPage.prototype.goToCastellerDet = function (casteller) {
        // go to the session detail page
        // and pass in the session data
        this.navCtrl.push(CastellerViewPage, casteller);
    };
    return CastellerListPage;
}());
__decorate([
    ViewChild('castellerlist', { read: List }),
    __metadata("design:type", List)
], CastellerListPage.prototype, "castellerlist", void 0);
CastellerListPage = __decorate([
    Component({
        selector: 'castellers-list',
        templateUrl: 'castellers-list.html'
    }),
    __metadata("design:paramtypes", [ActionSheetController,
        NavController,
        App,
        Config,
        CastellersService,
        StoreData])
], CastellerListPage);
export { CastellerListPage };
//# sourceMappingURL=castellers-list.js.map