/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espaa (CC BY-NC 3.0 ES)
**/
import { Component, ViewChild } from '@angular/core';

import { ActionSheet, App, ActionSheetController, Config, NavController, List } from 'ionic-angular';
import { InAppBrowser } from 'ionic-native';

import { CastellersService} from '../../providers/castellers.service'
import { CastellerViewPage } from '../castellers-det/castellers-view';

import { Casteller } from '../../entities/entities';
import { StoreData} from '../../providers/storage.data'
@Component({
  selector: 'castellers-list',
  templateUrl: 'castellers-list.html'
})
export class CastellerListPage {
  actionSheet: ActionSheet;
  lstCastellers: Casteller[] = [];
  queryText: String = "";
  @ViewChild('castellerlist', { read: List }) castellerlist: List;

  constructor(
    public actionSheetCtrl: ActionSheetController,
    public navCtrl: NavController,
    public app: App,
    public config: Config,
    public castellerService: CastellersService,
    public storeData: StoreData
  ) { }

  ionViewDidLoad() {
      this.app.setTitle('Castellers');
      this.load();
  }

  load() {
     
      this.castellerlist && this.castellerlist.closeSlidingItems();
      this.lstCastellers =this.storeData.getCastellers();
    
  }

  searchCastellers(ev: any) {
      this.lstCastellers = this.storeData.getCastellers();
      var val = ev.target.value;

      this.lstCastellers = this.lstCastellers.filter((item) => {
          if ((item.Name.toLowerCase().indexOf(val.toLowerCase()) > -1))
              return true;
          if ((item.LastName.toLowerCase().indexOf(val.toLowerCase()) > -1))
              return true;
          if ((item.Alias.toLowerCase().indexOf(val.toLowerCase()) > -1))
              return true;
          return false;
      })
  }

  goToCastellerDet(casteller: Casteller) {
      // go to the session detail page
      // and pass in the session data
      this.navCtrl.push(CastellerViewPage, casteller);
  } 
      
}
