var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Component } from '@angular/core';
import { NavParams } from 'ionic-angular';
import { AlertController, NavController, ModalController, ToastController, LoadingController } from 'ionic-angular';
import { EsdevenimentEditPage } from './esdeveniment-edit';
import { AssistenciaEditPage } from '../assistencia-det/assistencia-edit';
import { StoreData } from '../../providers/storage.data';
import { AssistenciaService } from '../../providers/assistencia.service';
var EsdevenimentViewPage = (function () {
    function EsdevenimentViewPage(navCtrl, navParams, alertCtrl, store, modalCtrl, loadingCtrl, toastCtrl, assistenciaService) {
        var _this = this;
        this.navCtrl = navCtrl;
        this.navParams = navParams;
        this.alertCtrl = alertCtrl;
        this.store = store;
        this.modalCtrl = modalCtrl;
        this.loadingCtrl = loadingCtrl;
        this.toastCtrl = toastCtrl;
        this.assistenciaService = assistenciaService;
        this.esdeveniment = navParams.data;
        if (this.store.isCasteller()) {
            var assistencia = this.store.getUserSession().Casteller.ConfirmPrecence;
            if (!assistencia) {
                this.puedeConfirmar = true;
                this.puedeDesconfirmar = false;
            }
            else {
                this.puedeDesconfirmar = false;
                assistencia.forEach(function (it) { if (it.Esdeveniment.Id === _this.esdeveniment.Id)
                    _this.puedeDesconfirmar = true; });
                this.puedeConfirmar = !this.puedeDesconfirmar;
            }
        }
        else {
            this.puedeConfirmar = false;
            this.puedeDesconfirmar = false;
        }
    }
    EsdevenimentViewPage.prototype.isJunta = function () {
        return this.store.isJunta();
    };
    EsdevenimentViewPage.prototype.editEsdeveniment = function () {
        this.navCtrl.push(EsdevenimentEditPage, this.esdeveniment);
    };
    EsdevenimentViewPage.prototype.addEsdeveniment = function () {
        this.navCtrl.push(EsdevenimentEditPage);
    };
    EsdevenimentViewPage.prototype.showConfirm = function () {
        var _this = this;
        var assistencia = {
            Casteller: this.store.getUserSession().Casteller,
            Esdeveniment: this.esdeveniment,
            Transport: null
        };
        if (this.esdeveniment.OfereixTransport || this.store.getUserSession().Casteller.AccepInvitations) {
            var modal = this.modalCtrl.create(AssistenciaEditPage, { assistencia: assistencia, type: "new" });
            modal.present();
            modal.onWillDismiss(function (data) {
                if (data) {
                    _this.puedeConfirmar = false;
                    _this.puedeDesconfirmar = true;
                    var toast = _this.toastCtrl.create({
                        message: 'S\'ha confirmat l\'assistencia correctament',
                        duration: 3000
                    });
                    toast.present();
                }
            });
        }
        else {
            var loading_1 = this.loadingCtrl.create({
                content: 'Esperi, s\'esta enviant la confirmacio al servidor'
            });
            loading_1.present();
            this.assistenciaService.saveAssistencia([assistencia], loading_1).subscribe(function (res) {
                _this.puedeConfirmar = false;
                _this.puedeDesconfirmar = true;
                _this.store.setAssistencia(res);
                loading_1.dismiss();
                var toast = _this.toastCtrl.create({
                    message: 'S\'ha confirmat l\'assistencia correctament',
                    duration: 3000
                });
                toast.present();
            }, function (err) {
                loading_1.dismiss();
                var alert = _this.alertCtrl.create({
                    title: 'Error en la confirmacio',
                    subTitle: "No se a podido confirmar (" + err + ")"
                });
                alert.present();
            });
        }
    };
    EsdevenimentViewPage.prototype.desconfirmEsdeveniment = function () {
        var _this = this;
        var loading = this.loadingCtrl.create({
            content: 'Esperi, s\'esta enviant la confirmacio al servidor'
        });
        loading.present();
        this.assistenciaService.removeAssistencia([{
                Casteller: this.store.getUserSession().Casteller, Esdeveniment: this.esdeveniment, NumAcompanyants: 0, Transport: false
            }], loading).subscribe(function (t) {
            _this.puedeConfirmar = true;
            _this.puedeDesconfirmar = false;
            _this.store.setAssistencia(t);
            loading.dismiss();
            var toast = _this.toastCtrl.create({
                message: 'S\'ha eliminat l\'assistencia amb els nous valors',
                duration: 3000
            });
            toast.present();
        }, function (err) {
            loading.dismiss();
            var alert = _this.alertCtrl.create({
                title: 'Error en la anulacio',
                subTitle: "No se a pogut anular (" + err + ")"
            });
            alert.present();
        });
    };
    return EsdevenimentViewPage;
}());
EsdevenimentViewPage = __decorate([
    Component({
        selector: 'esdeveniment-detail',
        templateUrl: 'esdeveniment-view.html'
    }),
    __metadata("design:paramtypes", [NavController,
        NavParams,
        AlertController,
        StoreData,
        ModalController,
        LoadingController,
        ToastController,
        AssistenciaService])
], EsdevenimentViewPage);
export { EsdevenimentViewPage };
//# sourceMappingURL=esdeveniment-view.js.map