/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espaa (CC BY-NC 3.0 ES)
**/
import { Component } from '@angular/core';

import { NavParams, ViewController } from 'ionic-angular';
 

@Component({
    selector: 'esdeveniment-filter', 
  templateUrl: 'esdeveniment-filter.html'
})
export class EsdevenimentFilterPage  {
    tracks: Array<{ name: string, isChecked: boolean }> = [{ name: "Entrenament", isChecked: true }, { name: "Diada", isChecked:true}];

  constructor( 
    public navParams: NavParams,
    public viewCtrl: ViewController
  ) {
      // passed in array of track names that should be excluded (unchecked)
      let excludedTrack: Array<any> = this.navParams.data;
      this.tracks.forEach(t => {
          excludedTrack.forEach(exclude => { if (exclude.name === t.name) t.isChecked = false; });
      });
     
  }

  resetFilters() { 
    this.tracks.forEach(track => {
      track.isChecked = true;
    });
  }

  applyFilters() {
    
    let excludedTrackNames = this.tracks.filter(c => !c.isChecked);
    this.dismiss(excludedTrackNames);
  }

  dismiss(data?: any) { 
    this.viewCtrl.dismiss(data);
  }
}
