var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Component, ViewChild } from '@angular/core';
import { AlertController, App, List, ModalController, NavController, LoadingController, ToastController } from 'ionic-angular';
import { EsdevenimentService } from '../../providers/esdeveniments.service';
import { EsdevenimentFilterPage } from './esdeveniment-filter';
import { EsdevenimentViewPage } from '../esdeveniment-det/esdeveniment-view';
import { StoreData } from '../../providers/storage.data';
var EsdevenimentListPage = (function () {
    function EsdevenimentListPage(alertCtrl, app, loadingCtrl, modalCtrl, navCtrl, storeData, esdevenimentService, toastCtrl) {
        this.alertCtrl = alertCtrl;
        this.app = app;
        this.loadingCtrl = loadingCtrl;
        this.modalCtrl = modalCtrl;
        this.navCtrl = navCtrl;
        this.storeData = storeData;
        this.esdevenimentService = esdevenimentService;
        this.toastCtrl = toastCtrl;
        this.dayIndex = 0;
        this.queryText = '';
        this.excludeTypes = [];
        this.lstEsdeveniment = [];
    }
    // ionViewDidLoad
    EsdevenimentListPage.prototype.ionViewDidEnter = function () {
        console.log("entra en Esdeveniments");
        this.app.setTitle('Calendari');
        this.loadEsdeveniments();
    };
    EsdevenimentListPage.prototype.loadEsdeveniments = function () {
        // Cierra los elementos
        if (this.lstEsdeveniment.length == 0) {
            if (this.storeData.getEsdeveniments()) {
                this.lstEsdeveniment = this.storeData.getEsdeveniments();
            }
            else {
                this.lstEsdeveniment = [];
            }
        }
        this.esdevenimentlist && this.esdevenimentlist.closeSlidingItems();
        // Compra si la fecha de publicacion hace m�s de una hora que no se actualiza
        /*let date: Date = this.storeData.getDataPubliEsdeveniments();
        let dateNow: Date = new Date();
        if (date != null)
            date.setHours(date.getHours() + 1);
  
        if (date == null || date.getTime() < dateNow.getTime()) {
            let loading = this.loadingCtrl.create({
                content: 'Actualizando Eventos'
            });
            loading.present();
            this.esdevenimentService.getEsdeveniments(0).subscribe(
                es => {
                    
                    this.storeData.saveEsdeveniments(es);
                    this.lstEsdeveniment = this.storeData.getEsdeveniments();
                    this.filterType();
                    loading.dismiss();
                },
                e => {
                    let toast = this.toastCtrl.create({
                        message: 'No s\'han actualitzat els esdeveniments',
                        duration: 3000
                    });
                    toast.present();
                    loading.dismiss();
                });
        } else {
            this.filterType();
            let toast = this.toastCtrl.create({
                message: 'No s\'ha actualitzat , data ultima actualitzacio ' + this.storeData.getDataPublicacioEsdeveniments(),
                duration: 3000
            });
            toast.present();
        }*/
    };
    EsdevenimentListPage.prototype.filterType = function () {
        var _this = this;
        var idtype = 0;
        if (this.excludeTypes.length != 0) {
            this.excludeTypes.forEach(function (t) {
                if (_this.excludeTypes[0].name === "Entrenament")
                    idtype += 1;
                else
                    idtype += 2;
            });
        }
        this.lstEsdeveniment = this.storeData.getEsdeveniments().filter(function (item) {
            if (idtype != 0 && item.EventTypeId != idtype)
                return false;
            if (_this.queryText.length == 0)
                return true;
            if (!(item.Description.toLowerCase().indexOf(_this.queryText.toLowerCase()) > -1) &&
                !(item.Tittle.toLowerCase().indexOf(_this.queryText.toLowerCase()) > -1))
                return false;
            return true;
        });
    };
    EsdevenimentListPage.prototype.searchEsdeveniments = function (ev) {
        this.lstEsdeveniment = this.storeData.getEsdeveniments();
        var val = ev.target.value;
        this.filterType();
    };
    EsdevenimentListPage.prototype.presentFilter = function () {
        var _this = this;
        var modal = this.modalCtrl.create(EsdevenimentFilterPage, this.excludeTypes);
        modal.present();
        modal.onWillDismiss(function (data) {
            if (data) {
                _this.excludeTypes = data;
            }
            else
                _this.excludeTypes = [];
            _this.filterType();
        });
    };
    EsdevenimentListPage.prototype.goToEsdevenimentDet = function (esdeveniment) {
        this.navCtrl.push(EsdevenimentViewPage, esdeveniment);
    };
    EsdevenimentListPage.prototype.isCasteller = function () {
        return this.storeData.isCasteller();
    };
    EsdevenimentListPage.prototype.showError = function (e) {
        // create an alert instance
        var alert = this.alertCtrl.create({
            title: 'Error in Esdeveniments ' + e
        });
        alert.present();
    };
    return EsdevenimentListPage;
}());
__decorate([
    ViewChild('esdevenimentlist', { read: List }),
    __metadata("design:type", List)
], EsdevenimentListPage.prototype, "esdevenimentlist", void 0);
EsdevenimentListPage = __decorate([
    Component({
        selector: 'esdeveniment-list',
        templateUrl: 'esdeveniment-list.html'
    }),
    __metadata("design:paramtypes", [AlertController,
        App,
        LoadingController,
        ModalController,
        NavController,
        StoreData,
        EsdevenimentService,
        ToastController])
], EsdevenimentListPage);
export { EsdevenimentListPage };
//# sourceMappingURL=esdeveniment-list.js.map