/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espaa (CC BY-NC 3.0 ES)
**/
import { Component, ViewChild } from '@angular/core';

import { AlertController, App,  List, ModalController, NavController, LoadingController, ToastController} from 'ionic-angular';

 
import { EsdevenimentService } from '../../providers/esdeveniments.service';
import { EsdevenimentFilterPage } from './esdeveniment-filter';
import { EsdevenimentViewPage } from '../esdeveniment-det/esdeveniment-view';

import { StoreData } from '../../providers/storage.data';
import { Esdeveniment, Assistencia} from '../../entities/entities'; 
@Component({
  selector: 'esdeveniment-list',
  templateUrl: 'esdeveniment-list.html'
})
export class EsdevenimentListPage {
 
    @ViewChild('esdevenimentlist', { read: List }) esdevenimentlist: List;

  dayIndex = 0;
  queryText = ''; 
  excludeTypes: any [] = [];
  lstEsdeveniment: Esdeveniment[] = [];  
  confDate: string; 
  constructor(
    public alertCtrl: AlertController,
    public app: App,
    public loadingCtrl: LoadingController,
    public modalCtrl: ModalController,
    public navCtrl: NavController,  
    public storeData: StoreData, 
    private esdevenimentService: EsdevenimentService,
    public toastCtrl: ToastController,
  ) {}
    // ionViewDidLoad
  ionViewDidEnter() {
      console.log("entra en Esdeveniments");
    this.app.setTitle('Calendari');
    this.loadEsdeveniments();
  }
    
       
  loadEsdeveniments() {
      // Cierra los elementos
      if (this.lstEsdeveniment.length==0){
          if (this.storeData.getEsdeveniments()) {
              this.lstEsdeveniment = this.storeData.getEsdeveniments(); 
          } else {
              this.lstEsdeveniment = [];
          }
      } 
      this.esdevenimentlist && this.esdevenimentlist.closeSlidingItems();

      // Compra si la fecha de publicacion hace ms de una hora que no se actualiza
      /*let date: Date = this.storeData.getDataPubliEsdeveniments();
      let dateNow: Date = new Date();
      if (date != null)
          date.setHours(date.getHours() + 1);

      if (date == null || date.getTime() < dateNow.getTime()) {
          let loading = this.loadingCtrl.create({
              content: 'Actualizando Eventos'
          });
          loading.present(); 
          this.esdevenimentService.getEsdeveniments(0).subscribe(
              es => {
                  
                  this.storeData.saveEsdeveniments(es);
                  this.lstEsdeveniment = this.storeData.getEsdeveniments();
                  this.filterType();
                  loading.dismiss();
              },
              e => {
                  let toast = this.toastCtrl.create({
                      message: 'No s\'han actualitzat els esdeveniments',
                      duration: 3000
                  });
                  toast.present();
                  loading.dismiss();
              });
      } else {
          this.filterType();
          let toast = this.toastCtrl.create({
              message: 'No s\'ha actualitzat , data ultima actualitzacio ' + this.storeData.getDataPublicacioEsdeveniments(),
              duration: 3000
          });
          toast.present();
      }*/
       
  }
 
  filterType(): void { 
        let idtype: number = 0;
        if (this.excludeTypes.length != 0) { 
            this.excludeTypes.forEach(t => {
                if (this.excludeTypes[0].name === "Entrenament") idtype += 1;
                else idtype += 2;
            });
        }
        this.lstEsdeveniment = this.storeData.getEsdeveniments().filter((item) => {
            if (idtype!=0 && item.EventTypeId != idtype)
                return false;
            if (this.queryText.length == 0)
                return true; 
            if (!(item.Description.toLowerCase().indexOf(this.queryText.toLowerCase()) > -1) &&
                !(item.Tittle.toLowerCase().indexOf(this.queryText.toLowerCase()) > -1))
                return false;
            return true;  
        });
          
      
  }
  searchEsdeveniments(ev:any) {
      this.lstEsdeveniment = this.storeData.getEsdeveniments();
      var val = ev.target.value;
      this.filterType();  
  }
    presentFilter() {
      let modal = this.modalCtrl.create(EsdevenimentFilterPage, this.excludeTypes);
        modal.present(); 
        modal.onWillDismiss((data: any[]) => {
            if (data) {
                this.excludeTypes = data;
            } else
                this.excludeTypes = [];

            this.filterType();
        }); 
  }

  goToEsdevenimentDet(esdeveniment: Esdeveniment) { 
      
      this.navCtrl.push(EsdevenimentViewPage, esdeveniment);
  }


  isCasteller(): boolean {
      return this.storeData.isCasteller();
  }
  
  showError(e: String) {
      // create an alert instance
      let alert = this.alertCtrl.create({
          title: 'Error in Esdeveniments ' + e
          
           
      }); 
      alert.present();
  } 
}
