var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Component } from '@angular/core';
import { Events, AlertController, NavController, LoadingController } from 'ionic-angular';
import { SignupPage } from '../signup/signup';
import { TabsPage } from '../tabs/tabs';
import { StoreData } from '../../providers/storage.data';
import { AuthenticateService } from "../../providers/authenticate.service";
var LoginPage = (function () {
    function LoginPage(navCtrl, storeData, authenticateService, events, alertCtrl, loadingCtrl) {
        this.navCtrl = navCtrl;
        this.storeData = storeData;
        this.authenticateService = authenticateService;
        this.events = events;
        this.alertCtrl = alertCtrl;
        this.loadingCtrl = loadingCtrl;
        this.login = {};
        this.submitted = false;
    }
    LoginPage.prototype.onLogin = function (form) {
        var _this = this;
        this.submitted = true;
        if (form.valid) {
            var loading_1 = this.loadingCtrl.create({
                content: 'Esperi, s\'esta enviant la confirmacio al servidor'
            });
            loading_1.present();
            this.authenticateService.login(this.login.username, this.login.password).subscribe(function (tk) {
                _this.onLoginResult(tk);
                loading_1.dismiss();
            }, function (err) {
                console.info(err);
                loading_1.dismiss();
                var alert = _this.alertCtrl.create({
                    title: 'Error en usuari o Password',
                    subTitle: "Validi que l\'usuari i el password siguin correctes.",
                    buttons: ['OK']
                });
                alert.present();
            });
        }
    };
    LoginPage.prototype.onLoginResult = function (tk) {
        if (tk != null && tk != "") {
            this.storeData.login(this.login.username, tk);
            this.navCtrl.push(TabsPage);
            this.navCtrl.resize();
        }
    };
    LoginPage.prototype.onSignup = function () {
        this.navCtrl.push(SignupPage);
    };
    return LoginPage;
}());
LoginPage = __decorate([
    Component({
        selector: 'page-user',
        templateUrl: 'login.html'
    }),
    __metadata("design:paramtypes", [NavController,
        StoreData,
        AuthenticateService,
        Events,
        AlertController,
        LoadingController])
], LoginPage);
export { LoginPage };
//# sourceMappingURL=login.js.map