/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espaa (CC BY-NC 3.0 ES)
**/
import {  Component } from '@angular/core';
import { NgForm } from '@angular/forms';

import { Events, AlertController, NavController, LoadingController } from 'ionic-angular';

import { SignupPage } from '../signup/signup';
import { TabsPage } from '../tabs/tabs';
import { StoreData } from '../../providers/storage.data'; 
 
import { AuthenticateService } from "../../providers/authenticate.service";
@Component({
  selector: 'oblidarContrasenya-usuari',
  templateUrl: 'login.html'
})
export class OblidarContrasenyaPage { 
  login: {username?: string} = {};
  submitted = false;

  constructor(
      public navCtrl: NavController,
      public storeData: StoreData,
      public authenticateService: AuthenticateService,
      public events: Events,
      public alertCtrl: AlertController,
      public loadingCtrl: LoadingController
        ) { }

  onSendMail(form: NgForm) {
    this.submitted = true;

    if (form.valid) {
        let loading = this.loadingCtrl.create({
            content: 'Esperi, s\'esta enviant la confirmacio al servidor'
        });
        loading.present();
        this.authenticateService.oblidarConstrasenya(this.login.username).subscribe(
            tk => { 
                loading.dismiss();
            }, err => {
                console.info(err);
                loading.dismiss(); 
            }); 
         
    }
  }  
}
