/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espaa (CC BY-NC 3.0 ES)
**/
import { Component, ViewChild, ElementRef } from '@angular/core';

import { StoreData } from '../../providers/storage.data';

import { Platform } from 'ionic-angular';


declare var google: any;

@Component({
  selector: 'page-map',
  templateUrl: 'map.html'
})
export class MapPage {

  @ViewChild('mapCanvas') mapElement: ElementRef;
  constructor(public confData: StoreData, public platform: Platform) {
  }

  ionViewDidLoad() { 
       
    let mapEle = this.mapElement.nativeElement;
  
    let latLng = new google.maps.LatLng(41.4336066, 2.1917966);
    let map = new google.maps.Map(mapEle, {
        center: latLng,
        zoom: 16
    });

   
    let infoWindow = new google.maps.InfoWindow({
        content: `<h5>Centre Entrenament</h5>`
    });

    let marker = new google.maps.Marker({
        map: map,
        animation: google.maps.Animation.DROP,
        position: map.getCenter()
    });

    marker.addListener('click', () => {
    infoWindow.open(map, marker);
    }); 

    google.maps.event.addListenerOnce(map, 'idle', () => {
        mapEle.classList.add('show-map');
    });

      

  }
}
