var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Component } from '@angular/core';
import { ActionSheetController, Config, NavController, Events } from 'ionic-angular';
import { InAppBrowser } from 'ionic-native';
import { StoreData } from '../../providers/storage.data';
import { NoticiesService } from '../../providers/noticies.service';
var NoticiesListPage = (function () {
    function NoticiesListPage(actionSheetCtrl, navCtrl, config, noticiesService, store, events) {
        var _this = this;
        this.actionSheetCtrl = actionSheetCtrl;
        this.navCtrl = navCtrl;
        this.config = config;
        this.noticiesService = noticiesService;
        this.store = store;
        this.events = events;
        this.noticies = [];
        this.events.subscribe('push:noticies', function () {
            console.log("Notificacion de noticias NoticiesList catched");
            _this.noticies = _this.store.getNoticies();
        });
    }
    NoticiesListPage.prototype.ionViewDidEnter = function () {
        if (this.noticies.length == 0) {
            if (this.store.getNoticies())
                this.noticies = this.store.getNoticies();
            else {
                this.noticies = [];
            }
        }
        this.store.clearNotification();
    };
    NoticiesListPage.prototype.goToUrl = function (not) {
        new InAppBrowser(not.Url, '_blank');
    };
    NoticiesListPage.prototype.openShare = function (not) {
        var mode = this.config.get('mode');
        var actionSheet = this.actionSheetCtrl.create({
            title: 'Correu electronic de  ' + not.UserInfo.Name + " " + not.UserInfo.LastName,
            buttons: [
                {
                    text: 'Copiar Correu',
                    icon: 'share',
                    handler: function ($event) {
                        if (window['cordova'] && window['cordova'].plugins.clipboard) {
                            window['cordova'].plugins.clipboard.copy(not.UserInfo.Email);
                        }
                    }
                },
                {
                    text: "Email ( " + not.UserInfo.Email + " )",
                    icon: mode !== 'ios' ? 'mail' : null,
                    handler: function () {
                        window.open('mailto:' + not.UserInfo.Email);
                    }
                },
                {
                    text: 'Cancel',
                    role: 'cancel'
                }
            ]
        });
        actionSheet.present();
    };
    return NoticiesListPage;
}());
NoticiesListPage = __decorate([
    Component({
        selector: 'noticies-list',
        templateUrl: 'noticies-list.html'
    }),
    __metadata("design:paramtypes", [ActionSheetController,
        NavController,
        Config,
        NoticiesService,
        StoreData,
        Events])
], NoticiesListPage);
export { NoticiesListPage };
//# sourceMappingURL=noticies-list.js.map