var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Component } from '@angular/core';
import { NavController, AlertController } from 'ionic-angular';
import { TabsPage } from '../tabs/tabs';
import { StoreData } from '../../providers/storage.data';
import { AuthenticateService } from "../../providers/authenticate.service";
var SignupPage = (function () {
    function SignupPage(alertCtrl, navCtrl, storeData, authenticateService) {
        this.alertCtrl = alertCtrl;
        this.navCtrl = navCtrl;
        this.storeData = storeData;
        this.authenticateService = authenticateService;
        this.error = "";
        this.signup = { Check: false };
        this.submitted = false;
    }
    SignupPage.prototype.onSignup = function (form) {
        var _this = this;
        this.error = "";
        if (form.valid) {
            if (this.signup.Check === false) {
                var alert_1 = this.alertCtrl.create({
                    title: 'Politica de protecci� de dades',
                    subTitle: "No ha acceptat la politica de proteccio de dades",
                    buttons: ['OK']
                });
                alert_1.present();
            }
            else if (!this.signup.Password || !this.signup.Password || this.signup.Password != this.signup.ConfirmPassword) {
                this.error = "Los passwords no son iguals";
            }
            else if (!this.signup.Email || !this.signup.ConfEmail || this.signup.ConfEmail != this.signup.Email) {
                this.error = "Els correus electronics no son iguals";
            }
            else if (this.signup.Password.length < 6)
                this.error = "Los passwords debe ser mayor que 6 caracteres";
            else {
                //Enviamos peticion al servidor.
                this.submitted = true;
                this.signup.Email.toLowerCase();
                this.signup.ConfEmail.toLowerCase();
                // En caso de que el formulario este todo Ok. SignUp al servidor
                this.authenticateService.signUp(this.signup).subscribe(function (t) {
                    // Si el Sign Up ok. Se hace el Login automaticamente.
                    _this.authenticateService.login(_this.signup.Email, _this.signup.Password).subscribe(function (tk) {
                        if (tk != null && tk != "") {
                            _this.storeData.login(_this.signup.Email, tk);
                            _this.navCtrl.push(TabsPage);
                            _this.navCtrl.resize();
                        }
                        var alert = _this.alertCtrl.create({
                            title: 'Bienvenido ' + _this.signup.Name,
                            subTitle: "S\'ha donat dalta correctament",
                            buttons: ['OK']
                        });
                        alert.present();
                        _this.submitted = false;
                    }, function (e) { return _this.submitted = false; });
                    _this.navCtrl.popAll();
                }, function (e) {
                    _this.submitted = false;
                });
            }
        }
        else {
            var alert_2 = this.alertCtrl.create({
                title: 'El formulari esta incomplet',
                subTitle: "El fomulario esta incompleto",
                buttons: ['OK']
            });
            alert_2.present();
        }
    };
    return SignupPage;
}());
SignupPage = __decorate([
    Component({
        selector: 'page-user',
        templateUrl: 'signup.html'
    }),
    __metadata("design:paramtypes", [AlertController, NavController, StoreData, AuthenticateService])
], SignupPage);
export { SignupPage };
//# sourceMappingURL=signup.js.map