/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espaa (CC BY-NC 3.0 ES)
**/
import { Component } from '@angular/core';
import { NgForm } from '@angular/forms';

import { NavController, AlertController} from 'ionic-angular';

import { TabsPage } from '../tabs/tabs';
import { StoreData  } from '../../providers/storage.data';
import { AuthenticateService } from "../../providers/authenticate.service";
import { Signup } from '../../entities/Signup'

@Component({
  selector: 'page-user',
  templateUrl: 'signup.html'
})
export class SignupPage { 
    error: String = "";
    signup: Signup = { Check:false };
  submitted = false; 
  constructor(public alertCtrl: AlertController,public navCtrl: NavController, public storeData: StoreData, public authenticateService: AuthenticateService) {}

  onSignup(form: NgForm) {
      
      this.error = "";
      if (form.valid) {
          if (this.signup.Check === false) {
              let alert = this.alertCtrl.create({
                  title: 'Politica de protecci de dades',
                  subTitle: "No ha acceptat la politica de proteccio de dades",
                  buttons: ['OK']
              });
              alert.present();
          }else
              if (!this.signup.Password || !this.signup.Password || this.signup.Password != this.signup.ConfirmPassword) {
              this.error = "Los passwords no son iguals";
          } else if (!this.signup.Email || !this.signup.ConfEmail || this.signup.ConfEmail != this.signup.Email) {
                  this.error = "Els correus electronics no son iguals";
          } else if (this.signup.Password.length < 6) this.error = "Los passwords debe ser mayor que 6 caracteres";
          else {
              //Enviamos peticion al servidor.
              this.submitted = true; 
              this.signup.Email.toLowerCase();
              this.signup.ConfEmail.toLowerCase();
              // En caso de que el formulario este todo Ok. SignUp al servidor
              this.authenticateService.signUp(this.signup).subscribe(
                  t => {
                      // Si el Sign Up ok. Se hace el Login automaticamente.
                      this.authenticateService.login(this.signup.Email, this.signup.Password).subscribe(tk => {
                          if (tk != null && tk != "") {
                              this.storeData.login(this.signup.Email, tk);
                              this.navCtrl.push(TabsPage);
                              this.navCtrl.resize(); 
                             
                          }
                          let alert = this.alertCtrl.create({
                              title: 'Bienvenido ' + this.signup.Name,
                              subTitle:"S\'ha donat dalta correctament",
                              buttons: ['OK']
                          });
                          alert.present();
                          this.submitted = false;
                      }, e => this.submitted = false);
                      this.navCtrl.popAll();
                  }, e => {
                      this.submitted = false 
                  });
              
          } 
      } else {
          let alert = this.alertCtrl.create({
              title: 'El formulari esta incomplet',
              subTitle:"El fomulario esta incompleto",
              buttons: ['OK']
          });
          alert.present();
        
      }
     
  }
    
}

