/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espaa (CC BY-NC 3.0 ES)
**/
import { Component } from '@angular/core';
import { NgForm } from '@angular/forms';
import { SupportService } from "../../providers/support.service";
import { NoticiesListPage } from "../noticies-list/noticies-list";
import { AlertController, NavController, ToastController } from 'ionic-angular';


@Component({
  selector: 'page-user',
  templateUrl: 'support.html'
})
export class SupportPage {

  submitted: boolean = false;
  supportMessage: string;

  constructor(
    public navCtrl: NavController,
    public alertCtrl: AlertController,
    public toastCtrl: ToastController,
    public supportService: SupportService
  ) {

  }

  ionViewDidEnter() {
    
  }

  submit(form: NgForm) {
    this.submitted = true;

    if (form.valid) {
        this.supportService.sendMailSupport(this.supportMessage).subscribe(t => {
            let toast = this.toastCtrl.create({
                message: 'S\'ha enviat notificacio a support',
                duration: 3000
            });
            toast.present(); 
        }, e=>{
            let toast = this.toastCtrl.create({
                message: 'Error: No s\'ha enviat el missatge',
                duration: 3000
            });
            toast.present(); 
            });
      this.supportMessage = '';
      this.submitted = false;
      this.navCtrl.setRoot(NoticiesListPage, { tabIndex: 0 });
    }
  }

   /*
  ionViewCanLeave(): boolean | Promise<boolean> {
    // If the support message is empty we should just navigate
    if (!this.supportMessage || this.supportMessage.trim().length === 0) {
      return true;
    } 
    return new Promise((resolve: any, reject: any) => {
      let alert = this.alertCtrl.create({
        title: 'Vols deixar la pagina?',
        message: 'Are you sure you want to leave this page? Your support message will not be submitted.'
      });
      alert.addButton({ text: 'Stay', handler: reject });
      alert.addButton({ text: 'Leave', role: 'cancel', handler: resolve });

      alert.present();
    });
  }*/
}
