/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espaa (CC BY-NC 3.0 ES)
**/
import { Component } from '@angular/core';

import { NavParams, Events} from 'ionic-angular';

import { SupportPage } from '../support/support';
import { MapPage } from '../map/map';
import { EsdevenimentListPage } from '../esdeveniment-list/esdeveniment-list';
import { NoticiesListPage } from '../noticies-list/noticies-list';
import { CastellerListPage } from '../castellers-list/castellers-list'; 
import { StoreData } from '../../providers/storage.data';
@Component({
  templateUrl: 'tabs.html'
})
export class TabsPage {
  // set the root pages for each tab
    tab1Root: any = NoticiesListPage;
    tab2Root: any = EsdevenimentListPage;
    tab3Root: any = CastellerListPage;
    tab4Root: any = SupportPage;
    mySelectedIndex: number;
    notification: string = null;
    constructor(navParams: NavParams, public store: StoreData, public events: Events) {
        this.mySelectedIndex = navParams.data.tabIndex || 0;
        this.notification = store.getNotificationNoticies().toString();
        if (this.notification === "0") this.notification = null;
        this.events.subscribe('push:noticies', () => {
            console.log("Notificacion de noticias TabsPage catched : " + store.getNotificationNoticies());
            this.notification = store.getNotificationNoticies().toString();
            if (this.notification === "0") this.notification = null;
        });

    }
    isCasteller(): boolean{
        return this.store.isCasteller();
    }



}
