var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Injectable } from '@angular/core';
import { RestService } from './RestBase.service';
import { Http } from '@angular/http';
import { StoreData } from './storage.data';
import { AlertController, ToastController } from 'ionic-angular';
import { MappingLocal } from './mapping.local';
var AssistenciaService = (function (_super) {
    __extends(AssistenciaService, _super);
    function AssistenciaService(http, store, alertCtrl, mapping, toastCtrl) {
        var _this = _super.call(this, store, alertCtrl, toastCtrl) || this;
        _this.http = http;
        _this.store = store;
        _this.alertCtrl = alertCtrl;
        _this.mapping = mapping;
        _this.toastCtrl = toastCtrl;
        return _this;
    }
    AssistenciaService.prototype.saveAssistencia = function (assis, loading) {
        var _this = this;
        if (this.mockEnabled) {
            var assistencia$ = this.http.get("assets/data/assistencies.json", this.getHeaders()).map(this.mapping.mapAssistenciaResponse).catch(function (e) { return _this.handleError(e); });
            return assistencia$;
        }
        else {
            var assistencia$ = this.http.put(this.rootPath + "/api/Assistencia/confirm", JSON.stringify(assis), this.getHeaders())
                .map(this.mapping.mapAssistenciaResponse).catch(function (e) { return _this.handleError(e, loading); });
            return assistencia$;
        }
    };
    AssistenciaService.prototype.removeAssistencia = function (assis, loading) {
        var _this = this;
        if (this.mockEnabled) {
            var assistencia$ = this.http.get("assets/data/assistencies.json", this.getHeaders()).map(this.mapping.mapAssistenciaResponse).catch(function (e) { return _this.handleError(e, loading); });
            return assistencia$;
        }
        else {
            var assistencia$ = this.http.post(this.rootPath + "/api/Assistencia/remove", JSON.stringify(assis), this.getHeaders())
                .map(this.mapping.mapAssistenciaResponse).catch(function (e) { return _this.handleError(e); });
            return assistencia$;
        }
    };
    AssistenciaService.prototype.getAssitenciaInvitacions = function (esdeveniment) {
        if (this.mockEnabled) {
            var assistencia$ = this.http.get("assets/data/assistencies.json", this.getHeaders()).map(this.mapping.mapAssistenciaResponse);
            return assistencia$;
        }
        else {
            var assistencia$ = this.http.post(this.rootPath + "/api/Assistencia/assitenciaInvitacions", JSON.stringify(esdeveniment), this.getHeaders())
                .map(this.mapping.mapAssistenciaResponse);
            return assistencia$;
        }
    };
    return AssistenciaService;
}(RestService));
AssistenciaService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [Http, StoreData, AlertController, MappingLocal, ToastController])
], AssistenciaService);
export { AssistenciaService };
//# sourceMappingURL=assistencia.service.js.map