var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Injectable } from '@angular/core';
import { Http } from '@angular/http';
import { StoreData } from './storage.data';
import { AlertController, ToastController } from 'ionic-angular';
import { RestService } from './RestBase.service';
import { MappingLocal } from './mapping.local';
/**
 * Clase responsable de las acciones del usuario sobre su cuenta
 */
var AuthenticateService = (function (_super) {
    __extends(AuthenticateService, _super);
    function AuthenticateService(http, store, alertCtrl, mapping, toastCtrl) {
        var _this = _super.call(this, store, alertCtrl, toastCtrl) || this;
        _this.http = http;
        _this.store = store;
        _this.alertCtrl = alertCtrl;
        _this.mapping = mapping;
        _this.toastCtrl = toastCtrl;
        return _this;
    }
    /**
     * Metodo para enviar el correo de confirmacion para saber si el usuario tiene el correo indicado
     * @param oldpass
     * @param newpass
     * @param confirmpass
     */
    AuthenticateService.prototype.sendMailConfirmation = function () {
        var sendConfirm$ = this.http.get(this.rootPath + "/api/User/sendMailConfirmation", this.getHeaders());
        return sendConfirm$;
    };
    /**
     *  * Metodo para enviar el correo de confirmacion para saber si el usuario tiene el correo indicado
     * @param name
     * @param lastName
     * @param email
     * @param password
     * @param repassword
     */
    AuthenticateService.prototype.signUp = function (signup) {
        var _this = this;
        var signUp1$ = this.http.post(this.rootPath + "/api/User/registerUser", JSON.stringify(signup), this.getHeaders()).catch(function (e) { return _this.handlerErrorForForms(e); });
        return signUp1$;
    };
    /**
     * Metodo para cambiar el password
     * @param oldpass
     * @param newpass
     * @param confirmpass
     */
    AuthenticateService.prototype.changePassword = function (oldpass, newpass, confirmpass) {
        var _this = this;
        var changePass$ = this.http.post(this.rootPath + "/api/User/changePassword", JSON.stringify({ OldPassword: oldpass, NewPassword: newpass, ConfirmPassword: confirmpass }), this.getHeaders()).catch(function (e) { return _this.handlerErrorForForms(e); });
        return changePass$;
    };
    /**
     * Metodo Login
     * @param user
     * @param pass
     */
    AuthenticateService.prototype.login = function (user, pass) {
        var _this = this;
        var token$ = this.http.post(this.rootPath + "/Token", "UserName=" + user + "&Password=" + pass + "&grant_type=password", this.getHeadersForToken())
            .map(this.mapToken)
            .catch(function (e) { return _this.handleError(e); });
        return token$;
    };
    /**
     * Mapea la entidad
     * @param response
     */
    AuthenticateService.prototype.mapToken = function (response) {
        return response.json().access_token;
    };
    /**
     * Recoger la informacion del Usuario actualizada
     * @param tk
     */
    AuthenticateService.prototype.getInfoUser = function () {
        var _this = this;
        if (this.mockEnabled) {
            console.warn("Mock Enabled getInfoUser");
            var token$ = this.http.get("assets/data/InfoGetUser.json", this.getHeaders()).map(this.mapping.mapUserInfoResponse);
            return token$;
        }
        else {
            console.debug("Acceso a Refresh " + this.store.getSessionToken);
            var token$ = this.http.get(this.rootPath + "/api/User/getUserInfo", this.getHeaders()).map(this.mapping.mapUserInfoResponse).catch(function (e) { return _this.handleError(e); });
            return token$;
        }
    };
    AuthenticateService.prototype.oblidarConstrasenya = function (user) {
        var _this = this;
        if (this.mockEnabled) {
            console.warn("Mock Enabled changePassword");
            var token$ = this.http.get("assets/data/InfoGetUser.json", this.getHeaders()).map(function (t) { return true; });
            return token$;
        }
        else {
            console.debug("Acceso a Refresh " + this.store.getSessionToken);
            var token$ = this.http.get(this.rootPath + "/api/User/oblidarConstrasenya?user=" + user, this.getHeaders()).map(function (t) { return true; }).catch(function (e) { return _this.handleError(e); });
            return token$;
        }
    };
    return AuthenticateService;
}(RestService));
AuthenticateService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [Http, StoreData, AlertController, MappingLocal, ToastController])
], AuthenticateService);
export { AuthenticateService };
//# sourceMappingURL=authenticate.service.js.map