var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Injectable } from '@angular/core';
import { RestService } from './RestBase.service';
import { Http } from '@angular/http';
import { StoreData } from './storage.data';
import { AlertController, ToastController } from 'ionic-angular';
import { MappingLocal } from './mapping.local';
var CastellersService = (function (_super) {
    __extends(CastellersService, _super);
    function CastellersService(http, store, alertCtrl, mapping, toastCtrl) {
        var _this = _super.call(this, store, alertCtrl, toastCtrl) || this;
        _this.http = http;
        _this.store = store;
        _this.alertCtrl = alertCtrl;
        _this.mapping = mapping;
        _this.toastCtrl = toastCtrl;
        return _this;
    }
    /**
     * Metodo de REST para obtener el listado de Castellers
     */
    CastellersService.prototype.getCasteller = function (data) {
        var _this = this;
        if (this.mockEnabled) {
            console.warn("Mock Enabled getCasteller");
            var castellers$ = this.http.get("assets/data/publicacionsCastellers.json", this.getHeaders()).map(this.mapping.mapPublicationCastellerResponse).catch(function (e) { return _this.handleError(e); });
            return castellers$;
        }
        else {
            data = data || "";
            var castellers$ = this.http.get(this.rootPath + "/api/Casteller/getAll?date=" + data, this.getHeaders())
                .map(this.mapping.mapPublicationCastellerResponse);
            return castellers$;
        }
    };
    CastellersService.prototype.enviaInvitacio = function (cas) {
        var _this = this;
        if (this.mockEnabled) {
            var assistencia$ = this.http.get("assets/data/delega.json", this.getHeaders()).map(this.mapping.mapCastellerResponse).catch(function (e) { return _this.handleError(e); });
            return assistencia$;
        }
        else {
            var assistencia$ = this.http.post(this.rootPath + "/api/Casteller/enviaInvitacio", JSON.stringify(cas), this.getHeaders())
                .map(this.mapping.mapCastellerResponse);
            return assistencia$;
        }
    };
    CastellersService.prototype.esborrarInvitacio = function (cas) {
        var _this = this;
        if (this.mockEnabled) {
            var assistencia$ = this.http.get("assets/data/delega.json", this.getHeaders()).map(this.mapping.mapCastellerResponse).catch(function (e) { return _this.handleError(e); });
            return assistencia$;
        }
        else {
            var assistencia$ = this.http.post(this.rootPath + "/api/Casteller/esborrarInvitacio", JSON.stringify(cas), this.getHeaders())
                .map(this.mapping.mapCastellerResponse);
            return assistencia$;
        }
    };
    CastellersService.prototype.esborrarAcceptacio = function (cas) {
        var _this = this;
        if (this.mockEnabled) {
            var assistencia$ = this.http.get("assets/data/delega.json", this.getHeaders()).map(this.mapping.mapCastellerResponse).catch(function (e) { return _this.handleError(e); });
            return assistencia$;
        }
        else {
            var assistencia$ = this.http.post(this.rootPath + "/api/Casteller/esborrarAcceptacio", JSON.stringify(cas), this.getHeaders())
                .map(this.mapping.mapCastellerResponse);
            return assistencia$;
        }
    };
    CastellersService.prototype.acceptarInvitacio = function (cas) {
        var _this = this;
        if (this.mockEnabled) {
            var assistencia$ = this.http.get("assets/data/delega.json", this.getHeaders()).map(this.mapping.mapCastellerResponse).catch(function (e) { return _this.handleError(e); });
            return assistencia$;
        }
        else {
            var assistencia$ = this.http.post(this.rootPath + "/api/Casteller/acceptarInvitacio", JSON.stringify(cas), this.getHeaders())
                .map(this.mapping.mapCastellerResponse);
            return assistencia$;
        }
    };
    CastellersService.prototype.esborrarAccepDelegacioPropia = function (cas) {
        var _this = this;
        if (this.mockEnabled) {
            var assistencia$ = this.http.post("assets/data/delega.json", this.getHeaders()).map(this.mapping.mapCastellerResponse).catch(function (e) { return _this.handleError(e); });
            return assistencia$;
        }
        else {
            var assistencia$ = this.http.post(this.rootPath + "/api/Casteller/esborrarAccepDelegacioPropia", JSON.stringify(cas), this.getHeaders())
                .map(this.mapping.mapCastellerResponse);
            return assistencia$;
        }
    };
    CastellersService.prototype.esborrarDelegacioPropia = function (cas) {
        var _this = this;
        if (this.mockEnabled) {
            var assistencia$ = this.http.post("assets/data/delega.json", this.getHeaders()).map(this.mapping.mapCastellerResponse).catch(function (e) { return _this.handleError(e); });
            return assistencia$;
        }
        else {
            var assistencia$ = this.http.post(this.rootPath + "/api/Casteller/esborrarDelegacioPropia", JSON.stringify(cas), this.getHeaders())
                .map(this.mapping.mapCastellerResponse);
            return assistencia$;
        }
    };
    return CastellersService;
}(RestService));
CastellersService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [Http, StoreData, AlertController, MappingLocal, ToastController])
], CastellersService);
export { CastellersService };
//# sourceMappingURL=castellers.service.js.map