var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espa�a (CC BY-NC 3.0 ES)
**/
import { Injectable } from '@angular/core';
import { RestService } from './RestBase.service';
import { Http } from '@angular/http';
import { StoreData } from './storage.data';
import { AlertController, ToastController } from 'ionic-angular';
import { MappingLocal } from './mapping.local';
var EsdevenimentService = (function (_super) {
    __extends(EsdevenimentService, _super);
    function EsdevenimentService(http, store, alertCtrl, mapping, toastCtrl) {
        var _this = _super.call(this, store, alertCtrl, toastCtrl) || this;
        _this.http = http;
        _this.store = store;
        _this.alertCtrl = alertCtrl;
        _this.mapping = mapping;
        _this.toastCtrl = toastCtrl;
        return _this;
    }
    /**
     * Metodo de REST para obtener el listado de eventos
     */
    EsdevenimentService.prototype.getEsdeveniments = function (filter) {
        var _this = this;
        if (this.mockEnabled) {
            var esdeveniments$ = this.http.get("assets/data/esdeveniments.json", this.getHeaders()).map(this.mapping.mapEsdevenimentResponse).catch(function (e) { return _this.handleError(e); });
            return esdeveniments$;
        }
        else {
            var esdeveniments$ = this.http.post(this.rootPath + "/api/Esdeveniment/getAll", JSON.stringify({ DataPublicacio: null, TipusEsdeveniments: filter }), this.getHeaders())
                .map(this.mapping.mapEsdevenimentResponse);
            return esdeveniments$;
        }
    };
    EsdevenimentService.prototype.getEsdevenimentsForUser = function () {
        var _this = this;
        if (this.mockEnabled) {
            var esdeveniments$ = this.http.get("assets/data/esdeveniments.json", this.getHeaders()).map(this.mapping.mapEsdevenimentResponse).catch(function (e) { return _this.handleError(e); });
            return esdeveniments$;
        }
        else {
            var esdeveniments$ = this.http.get(this.rootPath + "/api/Esdeveniment/GetForUser", this.getHeaders())
                .map(this.mapping.mapEsdevenimentResponse);
            return esdeveniments$;
        }
    };
    /**
        * Metodo Rest Get Id
        * @param id
        */
    EsdevenimentService.prototype.get = function (id) {
        var _this = this;
        var esdeveniments$ = this.http
            .get(this.rootPath + "/Esdeveniment/" + id, this.getHeaders())
            .map(this.mapping.mapEsdevenimentResponse).catch(function (e) { return _this.handleError(e); });
        return esdeveniments$;
    };
    /**
     * Salvar cambios d'evento
     * @param esdeveniment
     */
    EsdevenimentService.prototype.save = function (esdeveniment) {
        return this.http
            .put(this.rootPath + "/Esdeveniment/" + esdeveniment.Id, JSON.stringify(esdeveniment), this.getHeaders());
    };
    return EsdevenimentService;
}(RestService));
EsdevenimentService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [Http, StoreData, AlertController, MappingLocal, ToastController])
], EsdevenimentService);
export { EsdevenimentService };
//# sourceMappingURL=esdeveniments.service.js.map