var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
**/
import { Injectable } from '@angular/core';
var MappingLocal = (function () {
    function MappingLocal() {
    }
    MappingLocal.prototype.mapAssistenciaResponse = function (response) {
        return response.json().map(toAssistencia);
    };
    MappingLocal.prototype.mapCastellerResponse = function (response) {
        return response.json().map(toCasteller);
    };
    MappingLocal.prototype.mapPublicationCastellerResponse = function (response) {
        return toPublicationCasteller(response.json());
    };
    MappingLocal.prototype.mapCasteller = function (r) {
        return toCasteller(r);
    };
    MappingLocal.prototype.mapUserInfoResponse = function (response) {
        return toUserInfo(response.json());
    };
    MappingLocal.prototype.mapUserInfo = function (r) {
        return toUserInfo(r);
    };
    MappingLocal.prototype.mapNoticiesPublicacions = function (response) {
        return toPublicacions(response.json());
    };
    MappingLocal.prototype.mapNoticiesResponse = function (response) {
        return response.json().map(toNoticia);
    };
    MappingLocal.prototype.mapNoticies = function (r) {
        return toNoticia(r);
    };
    MappingLocal.prototype.mapEsdevenimentResponse = function (response) {
        return response.json().map(toEsdeveniment);
    };
    MappingLocal.prototype.mapEsdeveniment = function (r) {
        return toEsdeveniment(r);
    };
    return MappingLocal;
}());
MappingLocal = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [])
], MappingLocal);
export { MappingLocal };
/**
* Mapeador del Esdeveniment
* @param r Entidad JSON
*/
function toEsdeveniment(r) {
    if (!r)
        return null;
    var esdeveniment = ({
        Id: r.Id,
        Tittle: r.Tittle,
        Description: r.Description,
        DateIni: r.DateIniStr,
        DateFin: r.DateFinStr,
        HourIni: r.HourIniStr,
        HourFin: r.HourFinStr,
        EventTypeId: r.EventTypeId,
        EventType: r.EventType,
        OfereixTransport: r.OfereixTransport
    });
    console.log('Parsed Esdeveniment:', esdeveniment);
    return esdeveniment;
}
/**
 * Funcio de mapaix de l'informacio del usuari
 * @param response
 */
function toUserInfo(r) {
    if (!r)
        return null;
    var userInfo = ({
        Id: r.Id,
        Name: r.Name,
        LastName: r.LastName,
        Email: r.Email,
        ConfirmEmail: r.ConfirmEmail,
        ConfirmCasteller: r.ConfirmCasteller,
        PhoneNumber: r.PhoneNumber,
        Privilege: r.Privilege,
        Casteller: toCasteller(r.Casteller)
    });
    return userInfo;
}
function toPublicationCasteller(r) {
    if (!r)
        return null;
    var pubcas = ({
        Castellers: (r.Castellers) ? r.Castellers.map(toCasteller) : null,
        Date: r.Date
    });
    console.log('Parsed Noticia:', pubcas);
    return pubcas;
}
function toPublicacions(r) {
    if (!r)
        return null;
    var pub = ({
        DateEsdeveniments: r.DateEsdeveniments,
        DateNoticies: r.DateNoticies,
        Esdeveniments: (r.Esdeveniments) ? r.Esdeveniments.map(toEsdeveniment) : null,
        Noticies: (r.Noticies) ? r.Noticies.map(toNoticia) : null
    });
    console.log('Parsed Publication:', pub);
    return pub;
}
function toNoticia(r) {
    if (!r)
        return null;
    var noticia = ({
        Id: r.Id,
        Tittle: r.Tittle,
        Description: r.Description,
        Date: r.DateStr,
        Url: r.Url,
        UserInfo: toUserInfo(r.UserRef)
    });
    console.log('Parsed Noticia:', noticia);
    return noticia;
}
function toAssistencia(r) {
    if (!r)
        return null;
    var assistencia = ({
        Casteller: toCasteller(r.Casteller),
        Esdeveniment: toEsdeveniment(r.Esdeveniment),
        Transport: r.Transport,
        NumAcompanyants: r.NumAcompanyants,
        Observacions: r.Observacions
    });
    return assistencia;
}
function toCasteller(r) {
    if (!r)
        return null;
    var casteller = ({
        Id: r.Id,
        Alias: r.Alias,
        Name: r.Name,
        LastName: r.LastName,
        BirthDay: r.BirdhDay,
        Cancelation: r.Cancelation,
        CancelationDate: r.CancelationDate,
        ConfirmPrecence: (r.ConfirmPrecence) ? r.ConfirmPrecence.map(toAssistencia) : null,
        DateSignUp: r.DateSignUp,
        Depts: r.Depts,
        Email: r.Email,
        HasShirt: r.HasShirt,
        IdUser: r.IdUser,
        Invitations: (r.Invitations) ? r.Invitations.map(toCasteller) : [],
        DelegacioPropia: (r.DelegacioPropia) ? r.DelegacioPropia.map(toCasteller) : [],
        AccepDelegacioPropia: (r.AccepDelegacioPropia) ? r.AccepDelegacioPropia.map(toCasteller) : [],
        AccepInvitations: (r.AccepInvitations) ? r.AccepInvitations.map(toCasteller) : [],
        Phone1: r.Phone1,
        Phone2: r.Phone2,
    });
    return casteller;
}
//# sourceMappingURL=mapping.local.js.map