var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
**/
import { Injectable } from '@angular/core';
import { RestService } from './RestBase.service';
import { Http } from '@angular/http';
import { StoreData } from './storage.data';
import { AlertController, ToastController } from 'ionic-angular';
import { MappingLocal } from './mapping.local';
var PublicacionsService = (function (_super) {
    __extends(PublicacionsService, _super);
    function PublicacionsService(http, store, alertCtrl, mapping, toastCtrl) {
        var _this = _super.call(this, store, alertCtrl, toastCtrl) || this;
        _this.http = http;
        _this.store = store;
        _this.alertCtrl = alertCtrl;
        _this.mapping = mapping;
        _this.toastCtrl = toastCtrl;
        return _this;
    }
    /**
     * Metodo de REST para obtener el listado de Noticias
     */
    PublicacionsService.prototype.getPublicacions = function (publication) {
        var _this = this;
        if (this.mockEnabled) {
            var public$ = this.http.post("assets/data/publicacions.json", JSON.stringify(publication), this.getHeaders()).map(this.mapping.mapNoticiesPublicacions).catch(function (e) { return _this.handleError(e); });
            return public$;
        }
        else {
            var public$ = this.http.post(this.rootPath + "/api/Publicacions/public", JSON.stringify(publication), this.getHeaders())
                .map(this.mapping.mapNoticiesPublicacions);
            return public$;
        }
    };
    return PublicacionsService;
}(RestService));
PublicacionsService = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [Http, StoreData, AlertController, MappingLocal, ToastController])
], PublicacionsService);
export { PublicacionsService };
//# sourceMappingURL=publicacions.service.js.map