﻿/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
**/
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs/Rx';
import { Publication } from '../entities/entities';
import { RestService } from './RestBase.service';
import { RequestOptions, Http, Response, Headers } from '@angular/http';
import { StoreData } from './storage.data';
import { AlertController, ToastController} from 'ionic-angular';
import { MappingLocal } from './mapping.local';
@Injectable()
export class PublicacionsService extends RestService {

    constructor(private http: Http, public store: StoreData, public alertCtrl: AlertController, public mapping: MappingLocal, public toastCtrl: ToastController) {
        super(store, alertCtrl, toastCtrl);
    }
    /**
     * Metodo de REST para obtener el listado de Noticias
     */
    getPublicacions(publication: Publication): Observable<Publication> {
        if (this.mockEnabled) {
            let public$ = this.http.post(`assets/data/publicacions.json`, JSON.stringify(publication), this.getHeaders()).map(this.mapping.mapNoticiesPublicacions).catch(e => this.handleError(e));
            return public$;
        } else {
            let public$ = this.http.post(`${this.rootPath}/api/Publicacions/public`, JSON.stringify(publication), this.getHeaders())
                .map(this.mapping.mapNoticiesPublicacions);
            return public$;
        }
    }
    

}
