var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
**/
import { Injectable } from '@angular/core';
import { Events } from 'ionic-angular';
import { Storage } from '@ionic/storage';
var StoreData = (function () {
    function StoreData(events, storage) {
        this.events = events;
        this.storage = storage;
        /*Variables de Session Activa*/
        this._esdeveniments = [];
        this._noticies = [];
        this._countNoticies = 0;
        this._token = "";
        this._user = "";
        this._userInfo = null;
        this._hasSeenTutorial = true;
        this._dateActEsdeveniments = null;
        this._dateActNoticies = null;
        this._dateActCasteller = null;
        /* PARAMETROS DE MEMORIA */
        this.USER = 'username';
        this.TOKEN = 'token';
        this.USER_INFO = 'userInfo';
        this.HAS_SEEN_TUTORIAL = 'hasSeenTutorial';
        this.LIST_ESDEVENIMENTS = 'esdeveniments';
        this.LIST_NOTICIES = 'noticies';
        this.DATE_ACT_ESDEVENIMENTS = 'dataactesdeveniments';
        this.DATE_ACT_NOTICIES = 'dataactnoticies';
        this.DATE_ACT_CASTELLERS = 'dataactcastellers';
        this.CASTELLERS = 'castellers';
        this.load = 0;
    }
    StoreData.prototype.loadStore = function () {
        var _this = this;
        this.load = 0;
        console.info("Cargando variables en memoria");
        // 1
        this.storage.get(this.HAS_SEEN_TUTORIAL).then(function (value) {
            _this._hasSeenTutorial = value;
            _this.isLoaded();
        }).catch(function (e) { console.info("Error Carga HAS_SEEN_TUTORIAL:"); _this.isLoaded(); });
        // 2
        this.storage.get(this.TOKEN).then(function (t) {
            _this._token = t;
            _this.isLoaded();
        }).catch(function (e) { console.info("Error Carga TOKEN:"); _this.isLoaded(); });
        // 3
        this.storage.get(this.USER).then(function (value) {
            _this._user = value;
            _this.isLoaded();
        }).catch(function (e) { console.info("Error Carga USER:"); _this.isLoaded(); });
        // 4
        this.storage.get(this.USER_INFO).then(function (value) {
            _this._userInfo = value;
            _this.isLoaded();
        }).catch(function (e) { console.info("Error Carga USER_INFO:"); _this.isLoaded(); });
        // 5
        this.storage.get(this.DATE_ACT_ESDEVENIMENTS).then(function (value) {
            _this._dateActEsdeveniments = value;
            _this.isLoaded();
        }).catch(function (e) { console.info("Error Carga DATA_ACTUALITZACIO:"); _this.isLoaded(); });
        // 6
        this.storage.get(this.LIST_ESDEVENIMENTS).then(function (value) {
            _this._esdeveniments = value;
            _this.isLoaded();
        }).catch(function (e) { console.info("Error Carga ESDEVENIMENTS:"); _this.isLoaded(); });
        // 7
        this.storage.get(this.LIST_NOTICIES).then(function (value) {
            _this._noticies = value;
            _this.isLoaded();
        }).catch(function (e) { console.info("Error Carga LIST_NOTICIES:"); _this.isLoaded(); });
        // 8
        this.storage.get(this.DATE_ACT_NOTICIES).then(function (value) {
            _this._dateActNoticies = value;
            _this.isLoaded();
        }).catch(function (e) { console.info("Error Carga DATE_ACT_NOTICIES:"); _this.isLoaded(); });
        // 9
        this.storage.get(this.CASTELLERS).then(function (value) {
            _this._castellers = value;
            _this.isLoaded();
        }).catch(function (e) { console.info("Error Carga CASTELLERS:"); _this.isLoaded(); });
        //10 
        this.storage.get(this.DATE_ACT_CASTELLERS).then(function (value) {
            _this._dateActCasteller = value;
            _this.isLoaded();
        }).catch(function (e) { console.info("Error Carga DATE_ACT_CASTELLERS:"); _this.isLoaded(); });
    };
    StoreData.prototype.isLoaded = function () {
        this.load++;
        if (this.load == 9) {
            this.events.publish("store:load");
        }
    };
    StoreData.prototype.shipTutorial = function () {
        return this._hasSeenTutorial;
    };
    ;
    StoreData.prototype.getSessionToken = function () {
        return this._token;
    };
    StoreData.prototype.isCasteller = function () {
        if (!this._userInfo)
            return false;
        else if (this._userInfo.ConfirmCasteller) {
            return true;
        }
        else {
            return false;
        }
    };
    StoreData.prototype.isJunta = function () {
        if (!this._userInfo)
            return false;
        else if (this._userInfo.Privilege === "JUNTA") {
            return true;
        }
        else {
            return false;
        }
    };
    StoreData.prototype.getUsername = function () {
        return this._user;
    };
    ;
    StoreData.prototype.getDataPubliEsdeveniments = function () {
        return this._dateActEsdeveniments;
    };
    ;
    StoreData.prototype.getDataPubliNoticies = function () {
        return this._dateActNoticies;
    };
    ;
    StoreData.prototype.getDataPubliCastellers = function () {
        return this._dateActCasteller;
    };
    StoreData.prototype.clearNotification = function () {
        this._countNoticies = 0;
    };
    StoreData.prototype.getUserSession = function () {
        return this._userInfo;
    };
    StoreData.prototype.setAssistencia = function (assitencia) {
        this._userInfo.Casteller.ConfirmPrecence = assitencia;
        this.setUserSession(this._userInfo);
    };
    StoreData.prototype.setAcceptacions = function (castellers) {
        this._userInfo.Casteller.AccepInvitations = castellers || [];
        this.setUserSession(this._userInfo);
    };
    StoreData.prototype.setInvitations = function (castellers) {
        this._userInfo.Casteller.Invitations = castellers || [];
        this.setUserSession(this._userInfo);
    };
    StoreData.prototype.setDelegacioPropia = function (castellers) {
        this._userInfo.Casteller.DelegacioPropia = castellers || [];
        this.setUserSession(this._userInfo);
    };
    StoreData.prototype.setAccepDelegacioPropia = function (castellers) {
        this._userInfo.Casteller.DelegacioPropia = castellers || [];
        this.setUserSession(this._userInfo);
    };
    StoreData.prototype.setUserSession = function (user) {
        var _this = this;
        this._userInfo = user;
        this.storage.set(this.USER_INFO, user).then(function (t) { return console.info("Usuario actualizado"); }).catch(function (e) { console.info("Error Salvar USER_INFO:"); });
        if (this._userInfo.Casteller.ConfirmPrecence && this._esdeveniments) {
            this._userInfo.Casteller.ConfirmPrecence.forEach(function (ass) {
                _this._esdeveniments.some(function (es) {
                    if (es.Id === ass.Esdeveniment.Id) {
                        es.Confirmat = true;
                        return true;
                    }
                    else {
                        es.Confirmat = false;
                        return false;
                    }
                });
            });
        }
    };
    StoreData.prototype.saveEsdeveniments = function (lstEsdeveniments, dataPublicacio) {
        this._esdeveniments = lstEsdeveniments;
        this.storage.set(this.LIST_ESDEVENIMENTS, lstEsdeveniments);
        this.storage.set(this.DATE_ACT_ESDEVENIMENTS, dataPublicacio);
    };
    StoreData.prototype.getEsdeveniments = function () {
        var _this = this;
        if (this._userInfo && this._userInfo.ConfirmCasteller && this._esdeveniments && this._userInfo.Casteller.ConfirmPrecence) {
            this._esdeveniments.forEach(function (es) {
                es.Confirmat = false;
                _this._userInfo.Casteller.ConfirmPrecence.forEach(function (es1) {
                    if (es.Id === es1.Esdeveniment.Id)
                        es.Confirmat = true;
                });
            });
        }
        return this._esdeveniments;
    };
    StoreData.prototype.getCastellers = function () {
        return this._castellers;
    };
    StoreData.prototype.setCastellers = function (castellers, date) {
        var _this = this;
        if (!this._castellers) {
            this._castellers = castellers;
            this.storage.set(this.CASTELLERS, this._castellers);
            this.storage.set(this.DATE_ACT_CASTELLERS, date);
        }
        else if (castellers) {
            castellers.forEach(function (cas) {
                var i = 0;
                for (i = 0; i < _this._castellers.length; i++) {
                    if (cas.Id === _this._castellers[i].Id) {
                        _this._castellers[i] = cas;
                        break;
                    }
                }
                if (i >= _this._castellers.length) {
                    _this._castellers.push(cas);
                }
            });
            this.storage.set(this.CASTELLERS, this._castellers);
            this.storage.set(this.DATE_ACT_CASTELLERS, date);
        }
    };
    StoreData.prototype.saveNoticies = function (lstNoticies, datePublicacio) {
        var _this = this;
        this._countNoticies = 0;
        if (!lstNoticies)
            return;
        if (this._noticies) {
            lstNoticies.forEach(function (it) {
                var not = _this._noticies.find(function (it1) { return it1.Id === it.Id; });
                if (!not)
                    _this._countNoticies++;
            });
        }
        else {
            this._countNoticies = lstNoticies.length;
        }
        this._noticies = lstNoticies;
        this.storage.set(this.LIST_NOTICIES, lstNoticies);
        this.storage.set(this.DATE_ACT_NOTICIES, datePublicacio);
        this.events.publish("push:noticies");
        console.log("Enviada notificacion Noticies");
    };
    StoreData.prototype.getNotificationNoticies = function () {
        return this._countNoticies;
    };
    StoreData.prototype.getNoticies = function () {
        return this._noticies;
    };
    /**
     * Persiste la informacion del usuario en el dispositivo
 
     * @param userName
     * @param password
     * @param token
     */
    StoreData.prototype.login = function (userName, token) {
        this.storage.set(this.USER, userName);
        this.storage.set(this.TOKEN, token);
        this._token = token;
        this._user = userName;
        this.events.publish("user:login");
    };
    /**
     * Funcion de logout para borrar toda la informacion relacionda con la session del usuario
     */
    StoreData.prototype.logout = function () {
        this.clearMovil();
        this.events.publish("user:logout");
    };
    StoreData.prototype.clearUser = function () {
        this._user = null;
        this.storage.set(this.USER_INFO, null);
        this._userInfo = null;
        this.storage.set(this.TOKEN, null);
        this._token = null;
    };
    StoreData.prototype.clearMovil = function () {
        this.storage.set(this.USER, null);
        this._user = null;
        this.storage.set(this.USER_INFO, null);
        this._userInfo = null;
        this.storage.set(this.TOKEN, null);
        this._token = null;
        this.storage.set(this.CASTELLERS, null);
        this._castellers = null;
        this.storage.set(this.DATE_ACT_CASTELLERS, null);
        this._dateActCasteller = null;
        this.storage.set(this.DATE_ACT_ESDEVENIMENTS, null);
        this._dateActEsdeveniments = null;
        this.storage.set(this.DATE_ACT_NOTICIES, null);
        this._dateActNoticies = null;
        this.storage.set(this.LIST_NOTICIES, null);
        this.storage.set(this.LIST_ESDEVENIMENTS, null);
        this._esdeveniments = null;
    };
    return StoreData;
}());
StoreData = __decorate([
    Injectable(),
    __metadata("design:paramtypes", [Events,
        Storage])
], StoreData);
export { StoreData };
//# sourceMappingURL=storage.data.js.map