/**
    Author: Daniel Horta Vidal
    Licence: Reconocimiento-NoComercial 3.0 Espaa (CC BY-NC 3.0 ES)
**/
import { Injectable } from '@angular/core';
import { Http, Response } from '@angular/http';
import { Observable } from 'rxjs/Rx';
import { StoreData } from './storage.data';
import { AlertController, ToastController } from 'ionic-angular';
import { RestService } from './RestBase.service';  
/**
 * Clase responsable de las acciones del usuario sobre su cuenta
 */
@Injectable()
export class SupportService extends RestService{
    
    constructor(private http: Http, public store: StoreData, public alertCtrl: AlertController, public toastCtrl: ToastController) {
        super(store, alertCtrl, toastCtrl);
    }
    /**
     * Metodo para enviar el correo de sopporte 
     */
    sendMailSupport(message: String): Observable<Response> {
        let sendSuport$ = this.http.post(`${this.rootPath}/api/User/sendMailSupport`, JSON.stringify({"": message }), this.getHeaders());
        return sendSuport$;
    }
   
 
}
  