﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Web.Http;
using Microsoft.Owin.Security.OAuth;
using Newtonsoft.Json.Serialization;
/// <summary>
/// Aplicació de Gestió Castellera
/// </summary>
/// <copyright>
/// Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
/// </copyright>
/// <author>
/// Daniel Horta Vidal
/// </author>
namespace AppinyaServer
{
    public static class WebApiConfig
    {
       
        public static void Register(HttpConfiguration config)
        {
            // Web API configuration and services 
            config.SuppressDefaultHostAuthentication();
            config.Filters.Add(new HostAuthenticationFilter(OAuthDefaults.AuthenticationType));

            // Web API routes
            config.MapHttpAttributeRoutes(); 
            config.Routes.MapHttpRoute(
                name: "DefaultApi",
                routeTemplate: "api/{controller}/{id}",
                defaults: new { id = RouteParameter.Optional }
            );
          
            // Permite Poder hacer llamadas en dispositivos moviles 
            //var corsAttr = new System.Web.Http.Cors.EnableCorsAttribute("*", "*", "*");

            //config.EnableCors(corsAttr);
            // Enfoza HTTPS
            config.Filters.Add(new LocalAccountsApp.Filters.RequireHttpsAttribute());
            
            // Por defecto el text/html en JSON!
            config.Formatters.JsonFormatter.SupportedMediaTypes.Add(new System.Net.Http.Headers.MediaTypeHeaderValue("text/html"));
        }
    }
}
