﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;

using System.Web;
using AppinyaLib.Comunication;
using System.Configuration;
using AppinyaServer.Models;
using AppinyaLib.BS;
using AppinyaLib.Api;
using AppinyaLib.Database;
using AppinyaLib.Api.Entities;
/// <summary>
/// Aplicació de Gestió Castellera
/// </summary>
/// <copyright>
/// Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
/// </copyright>
/// <author>
/// Daniel Horta Vidal
/// </author>
namespace AppinyaServer.Controllers
{
    /**
     * Servicios para la gestion de esdevenimientos 
     */
    [AllowAnonymous]
    [RoutePrefix("api/Assistencia")]
    public class AssistenciaController : ApiControllerExtension
    {
        private static readonly log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        /*
         * POST: api/Esdeveniment/get Recoge la informacion de los eventos por Tipo y fecha de publicacion
         */
        // 

        [HttpPut]
        [Authorize]
        [Route("confirm")]
        public List<Assistencia> Confirmar(List<Assistencia> lstAssitencia)
        {
            
            String userName = GetUserName();

            if (lstAssitencia == null)
            {
                log.Error("Error Assistencia Confirmar" + userName);
                return null;
            }
            log.Info("Assistencia Confirmar" + userName);
            return AssistenciaBs.SaveAssistencia(lstAssitencia, userName);
        }
        [HttpPost]
        [Authorize]
        [Route("remove")]
        public List<Assistencia> Remove(List<Assistencia> lstAssitencia)
        {
            String userName = GetUserName();
            if (lstAssitencia == null)
            {
                log.Error("Error Assistencia Remove" + userName);
                return null;
            }
           
            log.Info("Assistencia Remove" + userName);
            return AssistenciaBs.RemoveAssistencia(lstAssitencia, userName);
        }
        [HttpPost]
        [Authorize]
        [Route("assitenciaInvitacions")]
        public List<Assistencia> AssitenciaInvitacions(Esdeveniment esdeveniment)
        {
            String userName = GetUserName();
            if (esdeveniment == null)
            {
                log.Error("Error Assistencia AssitenciaInvitacions" + userName);
                return null;
            }
         
            log.Info("Assistencia AssitenciaInvitacions" + userName);
            return AssistenciaBs.AssitenciaInvitacions(esdeveniment, userName);
        }
        


    }
}
