﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;

using System.Web;
using AppinyaLib.Comunication;
using System.Configuration;
using AppinyaServer.Models;
using AppinyaLib.BS;
using AppinyaLib.Api;
using AppinyaLib.Database;
using AppinyaLib.Api.Entities;
/// <summary>
/// Aplicació de Gestió Castellera
/// </summary>
/// <copyright>
/// Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
/// </copyright>
/// <author>
/// Daniel Horta Vidal
/// </author>
namespace AppinyaServer.Controllers
{
    [Authorize]
    [RoutePrefix("api/Casteller")]
    public class CastellerController : ApiControllerExtension
    {
        private static readonly log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        [HttpGet]
        [Route("getAll")]
        public CastellersPublication GetAll(String date=null)
        {
            String username = GetUserName();
            if(!UsuariBs.getUserInfo(username).ConfirmCasteller)
            {
                log.Warn("Se ha intentado acceder al api/Get con un usuario no permitido " + username);
                return null;
            }
            /*if (!isRoleJunta() && !isRoleAdmin())
             {
                 log.Warn("Se ha intentado acceder al api/Get con un usuario no permitido " + name);
                 return null;
             }*/
            log.Info("Se ha pedido actualizacion de castellers " + username + " date:" + date);
            return CastellerBs.GetAllCastellers(date);
           
        }

        [HttpPost]
        [Authorize]
        [Route("enviaInvitacio")]
        public List<Casteller> EnviaInvitacio(Casteller casteller)
        {
            if (casteller == null) return null;
            String userName = GetUserName();
            log.Info("Se envia petcion de EnviaInvitacio a " + userName + " -> " + casteller.Alias);
            return CastellerBs.EnviaInvitacio(casteller, userName);
        } 
        [HttpPost]
        [Authorize]
        [Route("esborrarInvitacio")]
        public List<Casteller> EsborrarInvitacio(Casteller casteller)
        {
            if (casteller == null) return null;
            String userName = GetUserName();
            log.Info("Se envia petcion de EsborrarInvitacio a " + userName + " -> " + casteller.Alias);
            return CastellerBs.EsborrarInvitacio(casteller, userName);
        }

        [HttpPost]
        [Authorize]
        [Route("esborrarAcceptacio")]
        public List<Casteller> EsborrarAcceptacio(Casteller casteller)
        {
            if (casteller==null) return null;
            String userName = GetUserName();
            log.Info("Se envia petcion de EsborrarAcceptacio a " + userName + " -> " + casteller.Alias);
            return CastellerBs.EsborrarAcceptacio(casteller, userName);
        }
        [HttpPost]
        [Authorize]
        [Route("esborrarDelegacioPropia")]
        public List<Casteller> EsborrarDelegacioPropia(Casteller casteller)
        {
            if (casteller == null) return null;
            String userName = GetUserName();
            log.Info("Se envia petcion de EsborrarDelegacioPropia a " + userName + " -> " + casteller.Alias);
            return CastellerBs.EsborrarDelegacioPropia(casteller, userName);
        }
        [HttpPost]
        [Authorize]
        [Route("esborrarAccepDelegacioPropia")]
        public List<Casteller> EsborrarAccepDelegacioPropia(Casteller casteller)
        {
            if (casteller == null) return null;
            String userName = GetUserName();
            log.Info("Se envia petcion de EsborrarAccepDelegacioPropia a " + userName + " -> " + casteller.Alias);
            return CastellerBs.EsborrarAccepDelegacioPropia(casteller, userName);
        }
        [HttpPost]
        [Authorize]
        [Route("acceptarInvitacio")]
        public List<Casteller> AcceptarInvitacio(Casteller casteller)
        {
            if (casteller == null) return null;
            String userName = GetUserName();
            log.Info("Se envia petcion de SendAssistenceDelegate a " + userName + " -> " + casteller.Alias);
            return CastellerBs.AcceptarInvitacio(casteller, userName);
        }
    }
}
