﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;

using System.Web;
using AppinyaLib.Comunication;
using System.Configuration;
using AppinyaServer.Models;
using AppinyaLib.BS;
using AppinyaLib.Api;
using AppinyaLib.Database;
using AppinyaLib.Api.Entities;
/// <summary>
/// Aplicació de Gestió Castellera
/// </summary>
/// <copyright>
/// Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
/// </copyright>
/// <author>
/// Daniel Horta Vidal
/// </author>
namespace AppinyaServer.Controllers
{
    /**
     * Servicios para la gestion de esdevenimientos 
     */
    [AllowAnonymous]
    [RoutePrefix("api/Esdeveniment")]
    public class EsdevenimentController : ApiControllerExtension
    {
        private static readonly log4net.ILog log = log4net.LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
        /*
         * POST: api/Esdeveniment/get Recoge la informacion de los eventos por Tipo y fecha de publicacion
         */
        // 
        [HttpPost]
        [Route("getAll")]
        public List<Esdeveniment> Get(EsdevenimentModel model)
        { 
            log.Info("Se descargan los registros de esdevenimento anonimo");
            return EsdevenimentsBs.GetEsdeveniments(model.TipusEsdeveniments).Select<ESDEVENIMENT, Esdeveniment>(x => x).ToList();
             

        }
        [Authorize]
        [Route("getAllForUser")]
        public List<Esdeveniment> GetForUser()
        {
            String userName = GetUserName();
            log.Info("Se descargan los registros de esdevenimento de un usuario" + userName);
            return EsdevenimentsBs.GetEsdevenimentsForUser(userName).Select<ESDEVENIMENT, Esdeveniment>(x => x).ToList();
        }
         
        // DELETE: api/Esdeveniment/5
        [Authorize]
        public void Delete(int id)
        {
            if( this.isRoleAdmin() ||this.isRoleJunta()) 
                EsdevenimentsBs.RemoveEsdeveniment(id);
            
                
        }

        
    }
}
