﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using AppinyaLib.Database;
using AppinyaLib.Api.Entities;
using AppinyaLib.Api;
using AppinyaLib.BS;
/// <summary>
/// Aplicació de Gestió Castellera
/// </summary>
/// <copyright>
/// Reconocimiento-NoComercial 3.0 España (CC BY-NC 3.0 ES)
/// </copyright>
/// <author>
/// Daniel Horta Vidal
/// </author>
namespace AppinyaServer.Controllers
{
    /// <summary>
    /// Publicacions Controller
    /// </summary>
    [RoutePrefix("api/Publicacions")]
    public class PublicacionsController : ApiControllerExtension
    {
        [HttpPost]
        [AllowAnonymous]
        [Route("public")]
        public Publication Public (Publication data)
        {
            Publication publication = null;
            using (castellersEntities db = new castellersEntities()) {
                DateTime dnoticies = db.ACTUALITZACIONS.Where(it => it.ID_TABLA == "NOTICIES").Select(t => t).FirstOrDefault().DATA_MODIFICACIO;
                DateTime desdeveniments = db.ACTUALITZACIONS.Where(it => it.ID_TABLA == "ESDEVENIMENT").Select(t => t).FirstOrDefault().DATA_MODIFICACIO;
                publication = new Publication()
                {
                    DateNoticies = ApiFunctions.convertApiDateHour(dnoticies),
                    DateEsdeveniments = ApiFunctions.convertApiDateHour(desdeveniments)
                };
                List<NOTICIES> lstNot = NoticiesBs.GetNoticies();
                List<ESDEVENIMENT> lstEsd = EsdevenimentsBs.GetEsdeveniments(0);
                if (data.DateNoticies == null || data.DateNoticies.CompareTo(publication.DateNoticies) != 0)
                    publication.Noticies = lstNot.Select<NOTICIES, Noticies>(t => t).ToList();
                if (data.DateEsdeveniments == null || data.DateEsdeveniments.CompareTo(publication.DateEsdeveniments) != 0)
                    publication.Esdeveniments = lstEsd.Select<ESDEVENIMENT, Esdeveniment>(t => t).ToList();
                return publication;
            }
           
        }
    }
}
